<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAccountPerformanceReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAccountPerformanceReportColumn
 * @subpackage Arrays
 */
class ArrayOfAccountPerformanceReportColumn extends AbstractStructArrayBase
{
    /**
     * The AccountPerformanceReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $AccountPerformanceReportColumn;
    /**
     * Constructor method for ArrayOfAccountPerformanceReportColumn
     * @uses ArrayOfAccountPerformanceReportColumn::setAccountPerformanceReportColumn()
     * @param string[] $accountPerformanceReportColumn
     */
    public function __construct(array $accountPerformanceReportColumn = array())
    {
        $this
            ->setAccountPerformanceReportColumn($accountPerformanceReportColumn);
    }
    /**
     * Get AccountPerformanceReportColumn value
     * @return string[]|null
     */
    public function getAccountPerformanceReportColumn()
    {
        return $this->AccountPerformanceReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setAccountPerformanceReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAccountPerformanceReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAccountPerformanceReportColumnForArrayConstraintsFromSetAccountPerformanceReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAccountPerformanceReportColumnAccountPerformanceReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\AccountPerformanceReportColumn::valueIsValid($arrayOfAccountPerformanceReportColumnAccountPerformanceReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfAccountPerformanceReportColumnAccountPerformanceReportColumnItem) ? get_class($arrayOfAccountPerformanceReportColumnAccountPerformanceReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfAccountPerformanceReportColumnAccountPerformanceReportColumnItem), var_export($arrayOfAccountPerformanceReportColumnAccountPerformanceReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AccountPerformanceReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\AccountPerformanceReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AccountPerformanceReportColumn value
     * @uses \EnumType\AccountPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\AccountPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $accountPerformanceReportColumn
     * @return \ArrayType\ArrayOfAccountPerformanceReportColumn
     */
    public function setAccountPerformanceReportColumn(array $accountPerformanceReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($accountPerformanceReportColumnArrayErrorMessage = self::validateAccountPerformanceReportColumnForArrayConstraintsFromSetAccountPerformanceReportColumn($accountPerformanceReportColumn))) {
            throw new \InvalidArgumentException($accountPerformanceReportColumnArrayErrorMessage, __LINE__);
        }
        $this->AccountPerformanceReportColumn = $accountPerformanceReportColumn;
        return $this;
    }
    /**
     * Add item to AccountPerformanceReportColumn value
     * @uses \EnumType\AccountPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\AccountPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfAccountPerformanceReportColumn
     */
    public function addToAccountPerformanceReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\AccountPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AccountPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\AccountPerformanceReportColumn::getValidValues())), __LINE__);
        }
        $this->AccountPerformanceReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\AccountPerformanceReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfAccountPerformanceReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\AccountPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AccountPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\AccountPerformanceReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AccountPerformanceReportColumn
     */
    public function getAttributeName()
    {
        return 'AccountPerformanceReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfAccountPerformanceReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
