<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAdDynamicTextPerformanceReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAdDynamicTextPerformanceReportColumn
 * @subpackage Arrays
 */
class ArrayOfAdDynamicTextPerformanceReportColumn extends AbstractStructArrayBase
{
    /**
     * The AdDynamicTextPerformanceReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $AdDynamicTextPerformanceReportColumn;
    /**
     * Constructor method for ArrayOfAdDynamicTextPerformanceReportColumn
     * @uses ArrayOfAdDynamicTextPerformanceReportColumn::setAdDynamicTextPerformanceReportColumn()
     * @param string[] $adDynamicTextPerformanceReportColumn
     */
    public function __construct(array $adDynamicTextPerformanceReportColumn = array())
    {
        $this
            ->setAdDynamicTextPerformanceReportColumn($adDynamicTextPerformanceReportColumn);
    }
    /**
     * Get AdDynamicTextPerformanceReportColumn value
     * @return string[]|null
     */
    public function getAdDynamicTextPerformanceReportColumn()
    {
        return $this->AdDynamicTextPerformanceReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setAdDynamicTextPerformanceReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdDynamicTextPerformanceReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdDynamicTextPerformanceReportColumnForArrayConstraintsFromSetAdDynamicTextPerformanceReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAdDynamicTextPerformanceReportColumnAdDynamicTextPerformanceReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\AdDynamicTextPerformanceReportColumn::valueIsValid($arrayOfAdDynamicTextPerformanceReportColumnAdDynamicTextPerformanceReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfAdDynamicTextPerformanceReportColumnAdDynamicTextPerformanceReportColumnItem) ? get_class($arrayOfAdDynamicTextPerformanceReportColumnAdDynamicTextPerformanceReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfAdDynamicTextPerformanceReportColumnAdDynamicTextPerformanceReportColumnItem), var_export($arrayOfAdDynamicTextPerformanceReportColumnAdDynamicTextPerformanceReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AdDynamicTextPerformanceReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\AdDynamicTextPerformanceReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdDynamicTextPerformanceReportColumn value
     * @uses \EnumType\AdDynamicTextPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\AdDynamicTextPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $adDynamicTextPerformanceReportColumn
     * @return \ArrayType\ArrayOfAdDynamicTextPerformanceReportColumn
     */
    public function setAdDynamicTextPerformanceReportColumn(array $adDynamicTextPerformanceReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($adDynamicTextPerformanceReportColumnArrayErrorMessage = self::validateAdDynamicTextPerformanceReportColumnForArrayConstraintsFromSetAdDynamicTextPerformanceReportColumn($adDynamicTextPerformanceReportColumn))) {
            throw new \InvalidArgumentException($adDynamicTextPerformanceReportColumnArrayErrorMessage, __LINE__);
        }
        $this->AdDynamicTextPerformanceReportColumn = $adDynamicTextPerformanceReportColumn;
        return $this;
    }
    /**
     * Add item to AdDynamicTextPerformanceReportColumn value
     * @uses \EnumType\AdDynamicTextPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\AdDynamicTextPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfAdDynamicTextPerformanceReportColumn
     */
    public function addToAdDynamicTextPerformanceReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\AdDynamicTextPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AdDynamicTextPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\AdDynamicTextPerformanceReportColumn::getValidValues())), __LINE__);
        }
        $this->AdDynamicTextPerformanceReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\AdDynamicTextPerformanceReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfAdDynamicTextPerformanceReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\AdDynamicTextPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AdDynamicTextPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\AdDynamicTextPerformanceReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdDynamicTextPerformanceReportColumn
     */
    public function getAttributeName()
    {
        return 'AdDynamicTextPerformanceReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfAdDynamicTextPerformanceReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
