<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAdExtensionByAdReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAdExtensionByAdReportColumn
 * @subpackage Arrays
 */
class ArrayOfAdExtensionByAdReportColumn extends AbstractStructArrayBase
{
    /**
     * The AdExtensionByAdReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $AdExtensionByAdReportColumn;
    /**
     * Constructor method for ArrayOfAdExtensionByAdReportColumn
     * @uses ArrayOfAdExtensionByAdReportColumn::setAdExtensionByAdReportColumn()
     * @param string[] $adExtensionByAdReportColumn
     */
    public function __construct(array $adExtensionByAdReportColumn = array())
    {
        $this
            ->setAdExtensionByAdReportColumn($adExtensionByAdReportColumn);
    }
    /**
     * Get AdExtensionByAdReportColumn value
     * @return string[]|null
     */
    public function getAdExtensionByAdReportColumn()
    {
        return $this->AdExtensionByAdReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setAdExtensionByAdReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdExtensionByAdReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdExtensionByAdReportColumnForArrayConstraintsFromSetAdExtensionByAdReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAdExtensionByAdReportColumnAdExtensionByAdReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\AdExtensionByAdReportColumn::valueIsValid($arrayOfAdExtensionByAdReportColumnAdExtensionByAdReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfAdExtensionByAdReportColumnAdExtensionByAdReportColumnItem) ? get_class($arrayOfAdExtensionByAdReportColumnAdExtensionByAdReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfAdExtensionByAdReportColumnAdExtensionByAdReportColumnItem), var_export($arrayOfAdExtensionByAdReportColumnAdExtensionByAdReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AdExtensionByAdReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\AdExtensionByAdReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdExtensionByAdReportColumn value
     * @uses \EnumType\AdExtensionByAdReportColumn::valueIsValid()
     * @uses \EnumType\AdExtensionByAdReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $adExtensionByAdReportColumn
     * @return \ArrayType\ArrayOfAdExtensionByAdReportColumn
     */
    public function setAdExtensionByAdReportColumn(array $adExtensionByAdReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($adExtensionByAdReportColumnArrayErrorMessage = self::validateAdExtensionByAdReportColumnForArrayConstraintsFromSetAdExtensionByAdReportColumn($adExtensionByAdReportColumn))) {
            throw new \InvalidArgumentException($adExtensionByAdReportColumnArrayErrorMessage, __LINE__);
        }
        $this->AdExtensionByAdReportColumn = $adExtensionByAdReportColumn;
        return $this;
    }
    /**
     * Add item to AdExtensionByAdReportColumn value
     * @uses \EnumType\AdExtensionByAdReportColumn::valueIsValid()
     * @uses \EnumType\AdExtensionByAdReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfAdExtensionByAdReportColumn
     */
    public function addToAdExtensionByAdReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\AdExtensionByAdReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AdExtensionByAdReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\AdExtensionByAdReportColumn::getValidValues())), __LINE__);
        }
        $this->AdExtensionByAdReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\AdExtensionByAdReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfAdExtensionByAdReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\AdExtensionByAdReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AdExtensionByAdReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\AdExtensionByAdReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdExtensionByAdReportColumn
     */
    public function getAttributeName()
    {
        return 'AdExtensionByAdReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfAdExtensionByAdReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
