<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAdExtensionByKeywordReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAdExtensionByKeywordReportColumn
 * @subpackage Arrays
 */
class ArrayOfAdExtensionByKeywordReportColumn extends AbstractStructArrayBase
{
    /**
     * The AdExtensionByKeywordReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $AdExtensionByKeywordReportColumn;
    /**
     * Constructor method for ArrayOfAdExtensionByKeywordReportColumn
     * @uses ArrayOfAdExtensionByKeywordReportColumn::setAdExtensionByKeywordReportColumn()
     * @param string[] $adExtensionByKeywordReportColumn
     */
    public function __construct(array $adExtensionByKeywordReportColumn = array())
    {
        $this
            ->setAdExtensionByKeywordReportColumn($adExtensionByKeywordReportColumn);
    }
    /**
     * Get AdExtensionByKeywordReportColumn value
     * @return string[]|null
     */
    public function getAdExtensionByKeywordReportColumn()
    {
        return $this->AdExtensionByKeywordReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setAdExtensionByKeywordReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdExtensionByKeywordReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdExtensionByKeywordReportColumnForArrayConstraintsFromSetAdExtensionByKeywordReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAdExtensionByKeywordReportColumnAdExtensionByKeywordReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\AdExtensionByKeywordReportColumn::valueIsValid($arrayOfAdExtensionByKeywordReportColumnAdExtensionByKeywordReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfAdExtensionByKeywordReportColumnAdExtensionByKeywordReportColumnItem) ? get_class($arrayOfAdExtensionByKeywordReportColumnAdExtensionByKeywordReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfAdExtensionByKeywordReportColumnAdExtensionByKeywordReportColumnItem), var_export($arrayOfAdExtensionByKeywordReportColumnAdExtensionByKeywordReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AdExtensionByKeywordReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\AdExtensionByKeywordReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdExtensionByKeywordReportColumn value
     * @uses \EnumType\AdExtensionByKeywordReportColumn::valueIsValid()
     * @uses \EnumType\AdExtensionByKeywordReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $adExtensionByKeywordReportColumn
     * @return \ArrayType\ArrayOfAdExtensionByKeywordReportColumn
     */
    public function setAdExtensionByKeywordReportColumn(array $adExtensionByKeywordReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($adExtensionByKeywordReportColumnArrayErrorMessage = self::validateAdExtensionByKeywordReportColumnForArrayConstraintsFromSetAdExtensionByKeywordReportColumn($adExtensionByKeywordReportColumn))) {
            throw new \InvalidArgumentException($adExtensionByKeywordReportColumnArrayErrorMessage, __LINE__);
        }
        $this->AdExtensionByKeywordReportColumn = $adExtensionByKeywordReportColumn;
        return $this;
    }
    /**
     * Add item to AdExtensionByKeywordReportColumn value
     * @uses \EnumType\AdExtensionByKeywordReportColumn::valueIsValid()
     * @uses \EnumType\AdExtensionByKeywordReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfAdExtensionByKeywordReportColumn
     */
    public function addToAdExtensionByKeywordReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\AdExtensionByKeywordReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AdExtensionByKeywordReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\AdExtensionByKeywordReportColumn::getValidValues())), __LINE__);
        }
        $this->AdExtensionByKeywordReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\AdExtensionByKeywordReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfAdExtensionByKeywordReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\AdExtensionByKeywordReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AdExtensionByKeywordReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\AdExtensionByKeywordReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdExtensionByKeywordReportColumn
     */
    public function getAttributeName()
    {
        return 'AdExtensionByKeywordReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfAdExtensionByKeywordReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
