<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAdExtensionDetailReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAdExtensionDetailReportColumn
 * @subpackage Arrays
 */
class ArrayOfAdExtensionDetailReportColumn extends AbstractStructArrayBase
{
    /**
     * The AdExtensionDetailReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $AdExtensionDetailReportColumn;
    /**
     * Constructor method for ArrayOfAdExtensionDetailReportColumn
     * @uses ArrayOfAdExtensionDetailReportColumn::setAdExtensionDetailReportColumn()
     * @param string[] $adExtensionDetailReportColumn
     */
    public function __construct(array $adExtensionDetailReportColumn = array())
    {
        $this
            ->setAdExtensionDetailReportColumn($adExtensionDetailReportColumn);
    }
    /**
     * Get AdExtensionDetailReportColumn value
     * @return string[]|null
     */
    public function getAdExtensionDetailReportColumn()
    {
        return $this->AdExtensionDetailReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setAdExtensionDetailReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdExtensionDetailReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdExtensionDetailReportColumnForArrayConstraintsFromSetAdExtensionDetailReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAdExtensionDetailReportColumnAdExtensionDetailReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\AdExtensionDetailReportColumn::valueIsValid($arrayOfAdExtensionDetailReportColumnAdExtensionDetailReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfAdExtensionDetailReportColumnAdExtensionDetailReportColumnItem) ? get_class($arrayOfAdExtensionDetailReportColumnAdExtensionDetailReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfAdExtensionDetailReportColumnAdExtensionDetailReportColumnItem), var_export($arrayOfAdExtensionDetailReportColumnAdExtensionDetailReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AdExtensionDetailReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\AdExtensionDetailReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdExtensionDetailReportColumn value
     * @uses \EnumType\AdExtensionDetailReportColumn::valueIsValid()
     * @uses \EnumType\AdExtensionDetailReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $adExtensionDetailReportColumn
     * @return \ArrayType\ArrayOfAdExtensionDetailReportColumn
     */
    public function setAdExtensionDetailReportColumn(array $adExtensionDetailReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($adExtensionDetailReportColumnArrayErrorMessage = self::validateAdExtensionDetailReportColumnForArrayConstraintsFromSetAdExtensionDetailReportColumn($adExtensionDetailReportColumn))) {
            throw new \InvalidArgumentException($adExtensionDetailReportColumnArrayErrorMessage, __LINE__);
        }
        $this->AdExtensionDetailReportColumn = $adExtensionDetailReportColumn;
        return $this;
    }
    /**
     * Add item to AdExtensionDetailReportColumn value
     * @uses \EnumType\AdExtensionDetailReportColumn::valueIsValid()
     * @uses \EnumType\AdExtensionDetailReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfAdExtensionDetailReportColumn
     */
    public function addToAdExtensionDetailReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\AdExtensionDetailReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AdExtensionDetailReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\AdExtensionDetailReportColumn::getValidValues())), __LINE__);
        }
        $this->AdExtensionDetailReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\AdExtensionDetailReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfAdExtensionDetailReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\AdExtensionDetailReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AdExtensionDetailReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\AdExtensionDetailReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdExtensionDetailReportColumn
     */
    public function getAttributeName()
    {
        return 'AdExtensionDetailReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfAdExtensionDetailReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
