<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAdGroupReportScope ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAdGroupReportScope
 * @subpackage Arrays
 */
class ArrayOfAdGroupReportScope extends AbstractStructArrayBase
{
    /**
     * The AdGroupReportScope
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AdGroupReportScope[]
     */
    public $AdGroupReportScope;
    /**
     * Constructor method for ArrayOfAdGroupReportScope
     * @uses ArrayOfAdGroupReportScope::setAdGroupReportScope()
     * @param \StructType\AdGroupReportScope[] $adGroupReportScope
     */
    public function __construct(array $adGroupReportScope = array())
    {
        $this
            ->setAdGroupReportScope($adGroupReportScope);
    }
    /**
     * Get AdGroupReportScope value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AdGroupReportScope[]|null
     */
    public function getAdGroupReportScope()
    {
        return isset($this->AdGroupReportScope) ? $this->AdGroupReportScope : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAdGroupReportScope method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdGroupReportScope method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdGroupReportScopeForArrayConstraintsFromSetAdGroupReportScope(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAdGroupReportScopeAdGroupReportScopeItem) {
            // validation for constraint: itemType
            if (!$arrayOfAdGroupReportScopeAdGroupReportScopeItem instanceof \StructType\AdGroupReportScope) {
                $invalidValues[] = is_object($arrayOfAdGroupReportScopeAdGroupReportScopeItem) ? get_class($arrayOfAdGroupReportScopeAdGroupReportScopeItem) : sprintf('%s(%s)', gettype($arrayOfAdGroupReportScopeAdGroupReportScopeItem), var_export($arrayOfAdGroupReportScopeAdGroupReportScopeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdGroupReportScope property can only contain items of type \StructType\AdGroupReportScope, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdGroupReportScope value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AdGroupReportScope[] $adGroupReportScope
     * @return \ArrayType\ArrayOfAdGroupReportScope
     */
    public function setAdGroupReportScope(array $adGroupReportScope = array())
    {
        // validation for constraint: array
        if ('' !== ($adGroupReportScopeArrayErrorMessage = self::validateAdGroupReportScopeForArrayConstraintsFromSetAdGroupReportScope($adGroupReportScope))) {
            throw new \InvalidArgumentException($adGroupReportScopeArrayErrorMessage, __LINE__);
        }
        if (is_null($adGroupReportScope) || (is_array($adGroupReportScope) && empty($adGroupReportScope))) {
            unset($this->AdGroupReportScope);
        } else {
            $this->AdGroupReportScope = $adGroupReportScope;
        }
        return $this;
    }
    /**
     * Add item to AdGroupReportScope value
     * @throws \InvalidArgumentException
     * @param \StructType\AdGroupReportScope $item
     * @return \ArrayType\ArrayOfAdGroupReportScope
     */
    public function addToAdGroupReportScope(\StructType\AdGroupReportScope $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AdGroupReportScope) {
            throw new \InvalidArgumentException(sprintf('The AdGroupReportScope property can only contain items of type \StructType\AdGroupReportScope, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdGroupReportScope[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AdGroupReportScope|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AdGroupReportScope|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AdGroupReportScope|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AdGroupReportScope|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AdGroupReportScope|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdGroupReportScope
     */
    public function getAttributeName()
    {
        return 'AdGroupReportScope';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfAdGroupReportScope
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
