<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAdPerformanceReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAdPerformanceReportColumn
 * @subpackage Arrays
 */
class ArrayOfAdPerformanceReportColumn extends AbstractStructArrayBase
{
    /**
     * The AdPerformanceReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $AdPerformanceReportColumn;
    /**
     * Constructor method for ArrayOfAdPerformanceReportColumn
     * @uses ArrayOfAdPerformanceReportColumn::setAdPerformanceReportColumn()
     * @param string[] $adPerformanceReportColumn
     */
    public function __construct(array $adPerformanceReportColumn = array())
    {
        $this
            ->setAdPerformanceReportColumn($adPerformanceReportColumn);
    }
    /**
     * Get AdPerformanceReportColumn value
     * @return string[]|null
     */
    public function getAdPerformanceReportColumn()
    {
        return $this->AdPerformanceReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setAdPerformanceReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdPerformanceReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdPerformanceReportColumnForArrayConstraintsFromSetAdPerformanceReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAdPerformanceReportColumnAdPerformanceReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\AdPerformanceReportColumn::valueIsValid($arrayOfAdPerformanceReportColumnAdPerformanceReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfAdPerformanceReportColumnAdPerformanceReportColumnItem) ? get_class($arrayOfAdPerformanceReportColumnAdPerformanceReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfAdPerformanceReportColumnAdPerformanceReportColumnItem), var_export($arrayOfAdPerformanceReportColumnAdPerformanceReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AdPerformanceReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\AdPerformanceReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdPerformanceReportColumn value
     * @uses \EnumType\AdPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\AdPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $adPerformanceReportColumn
     * @return \ArrayType\ArrayOfAdPerformanceReportColumn
     */
    public function setAdPerformanceReportColumn(array $adPerformanceReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($adPerformanceReportColumnArrayErrorMessage = self::validateAdPerformanceReportColumnForArrayConstraintsFromSetAdPerformanceReportColumn($adPerformanceReportColumn))) {
            throw new \InvalidArgumentException($adPerformanceReportColumnArrayErrorMessage, __LINE__);
        }
        $this->AdPerformanceReportColumn = $adPerformanceReportColumn;
        return $this;
    }
    /**
     * Add item to AdPerformanceReportColumn value
     * @uses \EnumType\AdPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\AdPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfAdPerformanceReportColumn
     */
    public function addToAdPerformanceReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\AdPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AdPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\AdPerformanceReportColumn::getValidValues())), __LINE__);
        }
        $this->AdPerformanceReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\AdPerformanceReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfAdPerformanceReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\AdPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AdPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\AdPerformanceReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdPerformanceReportColumn
     */
    public function getAttributeName()
    {
        return 'AdPerformanceReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfAdPerformanceReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
