<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAudiencePerformanceReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAudiencePerformanceReportColumn
 * @subpackage Arrays
 */
class ArrayOfAudiencePerformanceReportColumn extends AbstractStructArrayBase
{
    /**
     * The AudiencePerformanceReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $AudiencePerformanceReportColumn;
    /**
     * Constructor method for ArrayOfAudiencePerformanceReportColumn
     * @uses ArrayOfAudiencePerformanceReportColumn::setAudiencePerformanceReportColumn()
     * @param string[] $audiencePerformanceReportColumn
     */
    public function __construct(array $audiencePerformanceReportColumn = array())
    {
        $this
            ->setAudiencePerformanceReportColumn($audiencePerformanceReportColumn);
    }
    /**
     * Get AudiencePerformanceReportColumn value
     * @return string[]|null
     */
    public function getAudiencePerformanceReportColumn()
    {
        return $this->AudiencePerformanceReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setAudiencePerformanceReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAudiencePerformanceReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAudiencePerformanceReportColumnForArrayConstraintsFromSetAudiencePerformanceReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAudiencePerformanceReportColumnAudiencePerformanceReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\AudiencePerformanceReportColumn::valueIsValid($arrayOfAudiencePerformanceReportColumnAudiencePerformanceReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfAudiencePerformanceReportColumnAudiencePerformanceReportColumnItem) ? get_class($arrayOfAudiencePerformanceReportColumnAudiencePerformanceReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfAudiencePerformanceReportColumnAudiencePerformanceReportColumnItem), var_export($arrayOfAudiencePerformanceReportColumnAudiencePerformanceReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AudiencePerformanceReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\AudiencePerformanceReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AudiencePerformanceReportColumn value
     * @uses \EnumType\AudiencePerformanceReportColumn::valueIsValid()
     * @uses \EnumType\AudiencePerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $audiencePerformanceReportColumn
     * @return \ArrayType\ArrayOfAudiencePerformanceReportColumn
     */
    public function setAudiencePerformanceReportColumn(array $audiencePerformanceReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($audiencePerformanceReportColumnArrayErrorMessage = self::validateAudiencePerformanceReportColumnForArrayConstraintsFromSetAudiencePerformanceReportColumn($audiencePerformanceReportColumn))) {
            throw new \InvalidArgumentException($audiencePerformanceReportColumnArrayErrorMessage, __LINE__);
        }
        $this->AudiencePerformanceReportColumn = $audiencePerformanceReportColumn;
        return $this;
    }
    /**
     * Add item to AudiencePerformanceReportColumn value
     * @uses \EnumType\AudiencePerformanceReportColumn::valueIsValid()
     * @uses \EnumType\AudiencePerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfAudiencePerformanceReportColumn
     */
    public function addToAudiencePerformanceReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\AudiencePerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AudiencePerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\AudiencePerformanceReportColumn::getValidValues())), __LINE__);
        }
        $this->AudiencePerformanceReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\AudiencePerformanceReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfAudiencePerformanceReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\AudiencePerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AudiencePerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\AudiencePerformanceReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AudiencePerformanceReportColumn
     */
    public function getAttributeName()
    {
        return 'AudiencePerformanceReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfAudiencePerformanceReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
