<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBatchError ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBatchError
 * @subpackage Arrays
 */
class ArrayOfBatchError extends AbstractStructArrayBase
{
    /**
     * The BatchError
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BatchError[]
     */
    public $BatchError;
    /**
     * Constructor method for ArrayOfBatchError
     * @uses ArrayOfBatchError::setBatchError()
     * @param \StructType\BatchError[] $batchError
     */
    public function __construct(array $batchError = array())
    {
        $this
            ->setBatchError($batchError);
    }
    /**
     * Get BatchError value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BatchError[]|null
     */
    public function getBatchError()
    {
        return isset($this->BatchError) ? $this->BatchError : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBatchError method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBatchError method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBatchErrorForArrayConstraintsFromSetBatchError(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBatchErrorBatchErrorItem) {
            // validation for constraint: itemType
            if (!$arrayOfBatchErrorBatchErrorItem instanceof \StructType\BatchError) {
                $invalidValues[] = is_object($arrayOfBatchErrorBatchErrorItem) ? get_class($arrayOfBatchErrorBatchErrorItem) : sprintf('%s(%s)', gettype($arrayOfBatchErrorBatchErrorItem), var_export($arrayOfBatchErrorBatchErrorItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BatchError property can only contain items of type \StructType\BatchError, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BatchError value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\BatchError[] $batchError
     * @return \ArrayType\ArrayOfBatchError
     */
    public function setBatchError(array $batchError = array())
    {
        // validation for constraint: array
        if ('' !== ($batchErrorArrayErrorMessage = self::validateBatchErrorForArrayConstraintsFromSetBatchError($batchError))) {
            throw new \InvalidArgumentException($batchErrorArrayErrorMessage, __LINE__);
        }
        if (is_null($batchError) || (is_array($batchError) && empty($batchError))) {
            unset($this->BatchError);
        } else {
            $this->BatchError = $batchError;
        }
        return $this;
    }
    /**
     * Add item to BatchError value
     * @throws \InvalidArgumentException
     * @param \StructType\BatchError $item
     * @return \ArrayType\ArrayOfBatchError
     */
    public function addToBatchError(\StructType\BatchError $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BatchError) {
            throw new \InvalidArgumentException(sprintf('The BatchError property can only contain items of type \StructType\BatchError, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BatchError[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\BatchError|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\BatchError|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\BatchError|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\BatchError|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\BatchError|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BatchError
     */
    public function getAttributeName()
    {
        return 'BatchError';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfBatchError
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
