<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBudgetSummaryReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBudgetSummaryReportColumn
 * @subpackage Arrays
 */
class ArrayOfBudgetSummaryReportColumn extends AbstractStructArrayBase
{
    /**
     * The BudgetSummaryReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $BudgetSummaryReportColumn;
    /**
     * Constructor method for ArrayOfBudgetSummaryReportColumn
     * @uses ArrayOfBudgetSummaryReportColumn::setBudgetSummaryReportColumn()
     * @param string[] $budgetSummaryReportColumn
     */
    public function __construct(array $budgetSummaryReportColumn = array())
    {
        $this
            ->setBudgetSummaryReportColumn($budgetSummaryReportColumn);
    }
    /**
     * Get BudgetSummaryReportColumn value
     * @return string[]|null
     */
    public function getBudgetSummaryReportColumn()
    {
        return $this->BudgetSummaryReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setBudgetSummaryReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBudgetSummaryReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBudgetSummaryReportColumnForArrayConstraintsFromSetBudgetSummaryReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBudgetSummaryReportColumnBudgetSummaryReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\BudgetSummaryReportColumn::valueIsValid($arrayOfBudgetSummaryReportColumnBudgetSummaryReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfBudgetSummaryReportColumnBudgetSummaryReportColumnItem) ? get_class($arrayOfBudgetSummaryReportColumnBudgetSummaryReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfBudgetSummaryReportColumnBudgetSummaryReportColumnItem), var_export($arrayOfBudgetSummaryReportColumnBudgetSummaryReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\BudgetSummaryReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\BudgetSummaryReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BudgetSummaryReportColumn value
     * @uses \EnumType\BudgetSummaryReportColumn::valueIsValid()
     * @uses \EnumType\BudgetSummaryReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $budgetSummaryReportColumn
     * @return \ArrayType\ArrayOfBudgetSummaryReportColumn
     */
    public function setBudgetSummaryReportColumn(array $budgetSummaryReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($budgetSummaryReportColumnArrayErrorMessage = self::validateBudgetSummaryReportColumnForArrayConstraintsFromSetBudgetSummaryReportColumn($budgetSummaryReportColumn))) {
            throw new \InvalidArgumentException($budgetSummaryReportColumnArrayErrorMessage, __LINE__);
        }
        $this->BudgetSummaryReportColumn = $budgetSummaryReportColumn;
        return $this;
    }
    /**
     * Add item to BudgetSummaryReportColumn value
     * @uses \EnumType\BudgetSummaryReportColumn::valueIsValid()
     * @uses \EnumType\BudgetSummaryReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfBudgetSummaryReportColumn
     */
    public function addToBudgetSummaryReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\BudgetSummaryReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\BudgetSummaryReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\BudgetSummaryReportColumn::getValidValues())), __LINE__);
        }
        $this->BudgetSummaryReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\BudgetSummaryReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfBudgetSummaryReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\BudgetSummaryReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\BudgetSummaryReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\BudgetSummaryReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BudgetSummaryReportColumn
     */
    public function getAttributeName()
    {
        return 'BudgetSummaryReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfBudgetSummaryReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
