<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCallDetailReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCallDetailReportColumn
 * @subpackage Arrays
 */
class ArrayOfCallDetailReportColumn extends AbstractStructArrayBase
{
    /**
     * The CallDetailReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $CallDetailReportColumn;
    /**
     * Constructor method for ArrayOfCallDetailReportColumn
     * @uses ArrayOfCallDetailReportColumn::setCallDetailReportColumn()
     * @param string[] $callDetailReportColumn
     */
    public function __construct(array $callDetailReportColumn = array())
    {
        $this
            ->setCallDetailReportColumn($callDetailReportColumn);
    }
    /**
     * Get CallDetailReportColumn value
     * @return string[]|null
     */
    public function getCallDetailReportColumn()
    {
        return $this->CallDetailReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setCallDetailReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCallDetailReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCallDetailReportColumnForArrayConstraintsFromSetCallDetailReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCallDetailReportColumnCallDetailReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\CallDetailReportColumn::valueIsValid($arrayOfCallDetailReportColumnCallDetailReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfCallDetailReportColumnCallDetailReportColumnItem) ? get_class($arrayOfCallDetailReportColumnCallDetailReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfCallDetailReportColumnCallDetailReportColumnItem), var_export($arrayOfCallDetailReportColumnCallDetailReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\CallDetailReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\CallDetailReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CallDetailReportColumn value
     * @uses \EnumType\CallDetailReportColumn::valueIsValid()
     * @uses \EnumType\CallDetailReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $callDetailReportColumn
     * @return \ArrayType\ArrayOfCallDetailReportColumn
     */
    public function setCallDetailReportColumn(array $callDetailReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($callDetailReportColumnArrayErrorMessage = self::validateCallDetailReportColumnForArrayConstraintsFromSetCallDetailReportColumn($callDetailReportColumn))) {
            throw new \InvalidArgumentException($callDetailReportColumnArrayErrorMessage, __LINE__);
        }
        $this->CallDetailReportColumn = $callDetailReportColumn;
        return $this;
    }
    /**
     * Add item to CallDetailReportColumn value
     * @uses \EnumType\CallDetailReportColumn::valueIsValid()
     * @uses \EnumType\CallDetailReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfCallDetailReportColumn
     */
    public function addToCallDetailReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\CallDetailReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\CallDetailReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\CallDetailReportColumn::getValidValues())), __LINE__);
        }
        $this->CallDetailReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\CallDetailReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfCallDetailReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\CallDetailReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\CallDetailReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\CallDetailReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CallDetailReportColumn
     */
    public function getAttributeName()
    {
        return 'CallDetailReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCallDetailReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
