<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCampaignPerformanceReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCampaignPerformanceReportColumn
 * @subpackage Arrays
 */
class ArrayOfCampaignPerformanceReportColumn extends AbstractStructArrayBase
{
    /**
     * The CampaignPerformanceReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $CampaignPerformanceReportColumn;
    /**
     * Constructor method for ArrayOfCampaignPerformanceReportColumn
     * @uses ArrayOfCampaignPerformanceReportColumn::setCampaignPerformanceReportColumn()
     * @param string[] $campaignPerformanceReportColumn
     */
    public function __construct(array $campaignPerformanceReportColumn = array())
    {
        $this
            ->setCampaignPerformanceReportColumn($campaignPerformanceReportColumn);
    }
    /**
     * Get CampaignPerformanceReportColumn value
     * @return string[]|null
     */
    public function getCampaignPerformanceReportColumn()
    {
        return $this->CampaignPerformanceReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setCampaignPerformanceReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCampaignPerformanceReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCampaignPerformanceReportColumnForArrayConstraintsFromSetCampaignPerformanceReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCampaignPerformanceReportColumnCampaignPerformanceReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\CampaignPerformanceReportColumn::valueIsValid($arrayOfCampaignPerformanceReportColumnCampaignPerformanceReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfCampaignPerformanceReportColumnCampaignPerformanceReportColumnItem) ? get_class($arrayOfCampaignPerformanceReportColumnCampaignPerformanceReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfCampaignPerformanceReportColumnCampaignPerformanceReportColumnItem), var_export($arrayOfCampaignPerformanceReportColumnCampaignPerformanceReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\CampaignPerformanceReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\CampaignPerformanceReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CampaignPerformanceReportColumn value
     * @uses \EnumType\CampaignPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\CampaignPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $campaignPerformanceReportColumn
     * @return \ArrayType\ArrayOfCampaignPerformanceReportColumn
     */
    public function setCampaignPerformanceReportColumn(array $campaignPerformanceReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($campaignPerformanceReportColumnArrayErrorMessage = self::validateCampaignPerformanceReportColumnForArrayConstraintsFromSetCampaignPerformanceReportColumn($campaignPerformanceReportColumn))) {
            throw new \InvalidArgumentException($campaignPerformanceReportColumnArrayErrorMessage, __LINE__);
        }
        $this->CampaignPerformanceReportColumn = $campaignPerformanceReportColumn;
        return $this;
    }
    /**
     * Add item to CampaignPerformanceReportColumn value
     * @uses \EnumType\CampaignPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\CampaignPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfCampaignPerformanceReportColumn
     */
    public function addToCampaignPerformanceReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\CampaignPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\CampaignPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\CampaignPerformanceReportColumn::getValidValues())), __LINE__);
        }
        $this->CampaignPerformanceReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\CampaignPerformanceReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfCampaignPerformanceReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\CampaignPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\CampaignPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\CampaignPerformanceReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CampaignPerformanceReportColumn
     */
    public function getAttributeName()
    {
        return 'CampaignPerformanceReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCampaignPerformanceReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
