<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCampaignReportScope ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCampaignReportScope
 * @subpackage Arrays
 */
class ArrayOfCampaignReportScope extends AbstractStructArrayBase
{
    /**
     * The CampaignReportScope
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CampaignReportScope[]
     */
    public $CampaignReportScope;
    /**
     * Constructor method for ArrayOfCampaignReportScope
     * @uses ArrayOfCampaignReportScope::setCampaignReportScope()
     * @param \StructType\CampaignReportScope[] $campaignReportScope
     */
    public function __construct(array $campaignReportScope = array())
    {
        $this
            ->setCampaignReportScope($campaignReportScope);
    }
    /**
     * Get CampaignReportScope value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CampaignReportScope[]|null
     */
    public function getCampaignReportScope()
    {
        return isset($this->CampaignReportScope) ? $this->CampaignReportScope : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCampaignReportScope method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCampaignReportScope method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCampaignReportScopeForArrayConstraintsFromSetCampaignReportScope(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCampaignReportScopeCampaignReportScopeItem) {
            // validation for constraint: itemType
            if (!$arrayOfCampaignReportScopeCampaignReportScopeItem instanceof \StructType\CampaignReportScope) {
                $invalidValues[] = is_object($arrayOfCampaignReportScopeCampaignReportScopeItem) ? get_class($arrayOfCampaignReportScopeCampaignReportScopeItem) : sprintf('%s(%s)', gettype($arrayOfCampaignReportScopeCampaignReportScopeItem), var_export($arrayOfCampaignReportScopeCampaignReportScopeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CampaignReportScope property can only contain items of type \StructType\CampaignReportScope, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CampaignReportScope value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CampaignReportScope[] $campaignReportScope
     * @return \ArrayType\ArrayOfCampaignReportScope
     */
    public function setCampaignReportScope(array $campaignReportScope = array())
    {
        // validation for constraint: array
        if ('' !== ($campaignReportScopeArrayErrorMessage = self::validateCampaignReportScopeForArrayConstraintsFromSetCampaignReportScope($campaignReportScope))) {
            throw new \InvalidArgumentException($campaignReportScopeArrayErrorMessage, __LINE__);
        }
        if (is_null($campaignReportScope) || (is_array($campaignReportScope) && empty($campaignReportScope))) {
            unset($this->CampaignReportScope);
        } else {
            $this->CampaignReportScope = $campaignReportScope;
        }
        return $this;
    }
    /**
     * Add item to CampaignReportScope value
     * @throws \InvalidArgumentException
     * @param \StructType\CampaignReportScope $item
     * @return \ArrayType\ArrayOfCampaignReportScope
     */
    public function addToCampaignReportScope(\StructType\CampaignReportScope $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CampaignReportScope) {
            throw new \InvalidArgumentException(sprintf('The CampaignReportScope property can only contain items of type \StructType\CampaignReportScope, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CampaignReportScope[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CampaignReportScope|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CampaignReportScope|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CampaignReportScope|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CampaignReportScope|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CampaignReportScope|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CampaignReportScope
     */
    public function getAttributeName()
    {
        return 'CampaignReportScope';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCampaignReportScope
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
