<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfConversionPerformanceReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfConversionPerformanceReportColumn
 * @subpackage Arrays
 */
class ArrayOfConversionPerformanceReportColumn extends AbstractStructArrayBase
{
    /**
     * The ConversionPerformanceReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $ConversionPerformanceReportColumn;
    /**
     * Constructor method for ArrayOfConversionPerformanceReportColumn
     * @uses ArrayOfConversionPerformanceReportColumn::setConversionPerformanceReportColumn()
     * @param string[] $conversionPerformanceReportColumn
     */
    public function __construct(array $conversionPerformanceReportColumn = array())
    {
        $this
            ->setConversionPerformanceReportColumn($conversionPerformanceReportColumn);
    }
    /**
     * Get ConversionPerformanceReportColumn value
     * @return string[]|null
     */
    public function getConversionPerformanceReportColumn()
    {
        return $this->ConversionPerformanceReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setConversionPerformanceReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setConversionPerformanceReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateConversionPerformanceReportColumnForArrayConstraintsFromSetConversionPerformanceReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfConversionPerformanceReportColumnConversionPerformanceReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\ConversionPerformanceReportColumn::valueIsValid($arrayOfConversionPerformanceReportColumnConversionPerformanceReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfConversionPerformanceReportColumnConversionPerformanceReportColumnItem) ? get_class($arrayOfConversionPerformanceReportColumnConversionPerformanceReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfConversionPerformanceReportColumnConversionPerformanceReportColumnItem), var_export($arrayOfConversionPerformanceReportColumnConversionPerformanceReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\ConversionPerformanceReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\ConversionPerformanceReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ConversionPerformanceReportColumn value
     * @uses \EnumType\ConversionPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\ConversionPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $conversionPerformanceReportColumn
     * @return \ArrayType\ArrayOfConversionPerformanceReportColumn
     */
    public function setConversionPerformanceReportColumn(array $conversionPerformanceReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($conversionPerformanceReportColumnArrayErrorMessage = self::validateConversionPerformanceReportColumnForArrayConstraintsFromSetConversionPerformanceReportColumn($conversionPerformanceReportColumn))) {
            throw new \InvalidArgumentException($conversionPerformanceReportColumnArrayErrorMessage, __LINE__);
        }
        $this->ConversionPerformanceReportColumn = $conversionPerformanceReportColumn;
        return $this;
    }
    /**
     * Add item to ConversionPerformanceReportColumn value
     * @uses \EnumType\ConversionPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\ConversionPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfConversionPerformanceReportColumn
     */
    public function addToConversionPerformanceReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\ConversionPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\ConversionPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\ConversionPerformanceReportColumn::getValidValues())), __LINE__);
        }
        $this->ConversionPerformanceReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\ConversionPerformanceReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfConversionPerformanceReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\ConversionPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\ConversionPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\ConversionPerformanceReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ConversionPerformanceReportColumn
     */
    public function getAttributeName()
    {
        return 'ConversionPerformanceReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfConversionPerformanceReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
