<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDSAAutoTargetPerformanceReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDSAAutoTargetPerformanceReportColumn
 * @subpackage Arrays
 */
class ArrayOfDSAAutoTargetPerformanceReportColumn extends AbstractStructArrayBase
{
    /**
     * The DSAAutoTargetPerformanceReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $DSAAutoTargetPerformanceReportColumn;
    /**
     * Constructor method for ArrayOfDSAAutoTargetPerformanceReportColumn
     * @uses ArrayOfDSAAutoTargetPerformanceReportColumn::setDSAAutoTargetPerformanceReportColumn()
     * @param string[] $dSAAutoTargetPerformanceReportColumn
     */
    public function __construct(array $dSAAutoTargetPerformanceReportColumn = array())
    {
        $this
            ->setDSAAutoTargetPerformanceReportColumn($dSAAutoTargetPerformanceReportColumn);
    }
    /**
     * Get DSAAutoTargetPerformanceReportColumn value
     * @return string[]|null
     */
    public function getDSAAutoTargetPerformanceReportColumn()
    {
        return $this->DSAAutoTargetPerformanceReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setDSAAutoTargetPerformanceReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDSAAutoTargetPerformanceReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDSAAutoTargetPerformanceReportColumnForArrayConstraintsFromSetDSAAutoTargetPerformanceReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDSAAutoTargetPerformanceReportColumnDSAAutoTargetPerformanceReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\DSAAutoTargetPerformanceReportColumn::valueIsValid($arrayOfDSAAutoTargetPerformanceReportColumnDSAAutoTargetPerformanceReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfDSAAutoTargetPerformanceReportColumnDSAAutoTargetPerformanceReportColumnItem) ? get_class($arrayOfDSAAutoTargetPerformanceReportColumnDSAAutoTargetPerformanceReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfDSAAutoTargetPerformanceReportColumnDSAAutoTargetPerformanceReportColumnItem), var_export($arrayOfDSAAutoTargetPerformanceReportColumnDSAAutoTargetPerformanceReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\DSAAutoTargetPerformanceReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\DSAAutoTargetPerformanceReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DSAAutoTargetPerformanceReportColumn value
     * @uses \EnumType\DSAAutoTargetPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\DSAAutoTargetPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $dSAAutoTargetPerformanceReportColumn
     * @return \ArrayType\ArrayOfDSAAutoTargetPerformanceReportColumn
     */
    public function setDSAAutoTargetPerformanceReportColumn(array $dSAAutoTargetPerformanceReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($dSAAutoTargetPerformanceReportColumnArrayErrorMessage = self::validateDSAAutoTargetPerformanceReportColumnForArrayConstraintsFromSetDSAAutoTargetPerformanceReportColumn($dSAAutoTargetPerformanceReportColumn))) {
            throw new \InvalidArgumentException($dSAAutoTargetPerformanceReportColumnArrayErrorMessage, __LINE__);
        }
        $this->DSAAutoTargetPerformanceReportColumn = $dSAAutoTargetPerformanceReportColumn;
        return $this;
    }
    /**
     * Add item to DSAAutoTargetPerformanceReportColumn value
     * @uses \EnumType\DSAAutoTargetPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\DSAAutoTargetPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfDSAAutoTargetPerformanceReportColumn
     */
    public function addToDSAAutoTargetPerformanceReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\DSAAutoTargetPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\DSAAutoTargetPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\DSAAutoTargetPerformanceReportColumn::getValidValues())), __LINE__);
        }
        $this->DSAAutoTargetPerformanceReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\DSAAutoTargetPerformanceReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfDSAAutoTargetPerformanceReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\DSAAutoTargetPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\DSAAutoTargetPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\DSAAutoTargetPerformanceReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DSAAutoTargetPerformanceReportColumn
     */
    public function getAttributeName()
    {
        return 'DSAAutoTargetPerformanceReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDSAAutoTargetPerformanceReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
