<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDSACategoryPerformanceReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDSACategoryPerformanceReportColumn
 * @subpackage Arrays
 */
class ArrayOfDSACategoryPerformanceReportColumn extends AbstractStructArrayBase
{
    /**
     * The DSACategoryPerformanceReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $DSACategoryPerformanceReportColumn;
    /**
     * Constructor method for ArrayOfDSACategoryPerformanceReportColumn
     * @uses ArrayOfDSACategoryPerformanceReportColumn::setDSACategoryPerformanceReportColumn()
     * @param string[] $dSACategoryPerformanceReportColumn
     */
    public function __construct(array $dSACategoryPerformanceReportColumn = array())
    {
        $this
            ->setDSACategoryPerformanceReportColumn($dSACategoryPerformanceReportColumn);
    }
    /**
     * Get DSACategoryPerformanceReportColumn value
     * @return string[]|null
     */
    public function getDSACategoryPerformanceReportColumn()
    {
        return $this->DSACategoryPerformanceReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setDSACategoryPerformanceReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDSACategoryPerformanceReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDSACategoryPerformanceReportColumnForArrayConstraintsFromSetDSACategoryPerformanceReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDSACategoryPerformanceReportColumnDSACategoryPerformanceReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\DSACategoryPerformanceReportColumn::valueIsValid($arrayOfDSACategoryPerformanceReportColumnDSACategoryPerformanceReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfDSACategoryPerformanceReportColumnDSACategoryPerformanceReportColumnItem) ? get_class($arrayOfDSACategoryPerformanceReportColumnDSACategoryPerformanceReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfDSACategoryPerformanceReportColumnDSACategoryPerformanceReportColumnItem), var_export($arrayOfDSACategoryPerformanceReportColumnDSACategoryPerformanceReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\DSACategoryPerformanceReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\DSACategoryPerformanceReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DSACategoryPerformanceReportColumn value
     * @uses \EnumType\DSACategoryPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\DSACategoryPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $dSACategoryPerformanceReportColumn
     * @return \ArrayType\ArrayOfDSACategoryPerformanceReportColumn
     */
    public function setDSACategoryPerformanceReportColumn(array $dSACategoryPerformanceReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($dSACategoryPerformanceReportColumnArrayErrorMessage = self::validateDSACategoryPerformanceReportColumnForArrayConstraintsFromSetDSACategoryPerformanceReportColumn($dSACategoryPerformanceReportColumn))) {
            throw new \InvalidArgumentException($dSACategoryPerformanceReportColumnArrayErrorMessage, __LINE__);
        }
        $this->DSACategoryPerformanceReportColumn = $dSACategoryPerformanceReportColumn;
        return $this;
    }
    /**
     * Add item to DSACategoryPerformanceReportColumn value
     * @uses \EnumType\DSACategoryPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\DSACategoryPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfDSACategoryPerformanceReportColumn
     */
    public function addToDSACategoryPerformanceReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\DSACategoryPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\DSACategoryPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\DSACategoryPerformanceReportColumn::getValidValues())), __LINE__);
        }
        $this->DSACategoryPerformanceReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\DSACategoryPerformanceReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfDSACategoryPerformanceReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\DSACategoryPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\DSACategoryPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\DSACategoryPerformanceReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DSACategoryPerformanceReportColumn
     */
    public function getAttributeName()
    {
        return 'DSACategoryPerformanceReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDSACategoryPerformanceReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
