<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDSASearchQueryPerformanceReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDSASearchQueryPerformanceReportColumn
 * @subpackage Arrays
 */
class ArrayOfDSASearchQueryPerformanceReportColumn extends AbstractStructArrayBase
{
    /**
     * The DSASearchQueryPerformanceReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $DSASearchQueryPerformanceReportColumn;
    /**
     * Constructor method for ArrayOfDSASearchQueryPerformanceReportColumn
     * @uses ArrayOfDSASearchQueryPerformanceReportColumn::setDSASearchQueryPerformanceReportColumn()
     * @param string[] $dSASearchQueryPerformanceReportColumn
     */
    public function __construct(array $dSASearchQueryPerformanceReportColumn = array())
    {
        $this
            ->setDSASearchQueryPerformanceReportColumn($dSASearchQueryPerformanceReportColumn);
    }
    /**
     * Get DSASearchQueryPerformanceReportColumn value
     * @return string[]|null
     */
    public function getDSASearchQueryPerformanceReportColumn()
    {
        return $this->DSASearchQueryPerformanceReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setDSASearchQueryPerformanceReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDSASearchQueryPerformanceReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDSASearchQueryPerformanceReportColumnForArrayConstraintsFromSetDSASearchQueryPerformanceReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDSASearchQueryPerformanceReportColumnDSASearchQueryPerformanceReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\DSASearchQueryPerformanceReportColumn::valueIsValid($arrayOfDSASearchQueryPerformanceReportColumnDSASearchQueryPerformanceReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfDSASearchQueryPerformanceReportColumnDSASearchQueryPerformanceReportColumnItem) ? get_class($arrayOfDSASearchQueryPerformanceReportColumnDSASearchQueryPerformanceReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfDSASearchQueryPerformanceReportColumnDSASearchQueryPerformanceReportColumnItem), var_export($arrayOfDSASearchQueryPerformanceReportColumnDSASearchQueryPerformanceReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\DSASearchQueryPerformanceReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\DSASearchQueryPerformanceReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DSASearchQueryPerformanceReportColumn value
     * @uses \EnumType\DSASearchQueryPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\DSASearchQueryPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $dSASearchQueryPerformanceReportColumn
     * @return \ArrayType\ArrayOfDSASearchQueryPerformanceReportColumn
     */
    public function setDSASearchQueryPerformanceReportColumn(array $dSASearchQueryPerformanceReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($dSASearchQueryPerformanceReportColumnArrayErrorMessage = self::validateDSASearchQueryPerformanceReportColumnForArrayConstraintsFromSetDSASearchQueryPerformanceReportColumn($dSASearchQueryPerformanceReportColumn))) {
            throw new \InvalidArgumentException($dSASearchQueryPerformanceReportColumnArrayErrorMessage, __LINE__);
        }
        $this->DSASearchQueryPerformanceReportColumn = $dSASearchQueryPerformanceReportColumn;
        return $this;
    }
    /**
     * Add item to DSASearchQueryPerformanceReportColumn value
     * @uses \EnumType\DSASearchQueryPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\DSASearchQueryPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfDSASearchQueryPerformanceReportColumn
     */
    public function addToDSASearchQueryPerformanceReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\DSASearchQueryPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\DSASearchQueryPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\DSASearchQueryPerformanceReportColumn::getValidValues())), __LINE__);
        }
        $this->DSASearchQueryPerformanceReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\DSASearchQueryPerformanceReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfDSASearchQueryPerformanceReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\DSASearchQueryPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\DSASearchQueryPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\DSASearchQueryPerformanceReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DSASearchQueryPerformanceReportColumn
     */
    public function getAttributeName()
    {
        return 'DSASearchQueryPerformanceReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDSASearchQueryPerformanceReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
