<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDestinationUrlPerformanceReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDestinationUrlPerformanceReportColumn
 * @subpackage Arrays
 */
class ArrayOfDestinationUrlPerformanceReportColumn extends AbstractStructArrayBase
{
    /**
     * The DestinationUrlPerformanceReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $DestinationUrlPerformanceReportColumn;
    /**
     * Constructor method for ArrayOfDestinationUrlPerformanceReportColumn
     * @uses ArrayOfDestinationUrlPerformanceReportColumn::setDestinationUrlPerformanceReportColumn()
     * @param string[] $destinationUrlPerformanceReportColumn
     */
    public function __construct(array $destinationUrlPerformanceReportColumn = array())
    {
        $this
            ->setDestinationUrlPerformanceReportColumn($destinationUrlPerformanceReportColumn);
    }
    /**
     * Get DestinationUrlPerformanceReportColumn value
     * @return string[]|null
     */
    public function getDestinationUrlPerformanceReportColumn()
    {
        return $this->DestinationUrlPerformanceReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setDestinationUrlPerformanceReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDestinationUrlPerformanceReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDestinationUrlPerformanceReportColumnForArrayConstraintsFromSetDestinationUrlPerformanceReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDestinationUrlPerformanceReportColumnDestinationUrlPerformanceReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\DestinationUrlPerformanceReportColumn::valueIsValid($arrayOfDestinationUrlPerformanceReportColumnDestinationUrlPerformanceReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfDestinationUrlPerformanceReportColumnDestinationUrlPerformanceReportColumnItem) ? get_class($arrayOfDestinationUrlPerformanceReportColumnDestinationUrlPerformanceReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfDestinationUrlPerformanceReportColumnDestinationUrlPerformanceReportColumnItem), var_export($arrayOfDestinationUrlPerformanceReportColumnDestinationUrlPerformanceReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\DestinationUrlPerformanceReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\DestinationUrlPerformanceReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DestinationUrlPerformanceReportColumn value
     * @uses \EnumType\DestinationUrlPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\DestinationUrlPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $destinationUrlPerformanceReportColumn
     * @return \ArrayType\ArrayOfDestinationUrlPerformanceReportColumn
     */
    public function setDestinationUrlPerformanceReportColumn(array $destinationUrlPerformanceReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($destinationUrlPerformanceReportColumnArrayErrorMessage = self::validateDestinationUrlPerformanceReportColumnForArrayConstraintsFromSetDestinationUrlPerformanceReportColumn($destinationUrlPerformanceReportColumn))) {
            throw new \InvalidArgumentException($destinationUrlPerformanceReportColumnArrayErrorMessage, __LINE__);
        }
        $this->DestinationUrlPerformanceReportColumn = $destinationUrlPerformanceReportColumn;
        return $this;
    }
    /**
     * Add item to DestinationUrlPerformanceReportColumn value
     * @uses \EnumType\DestinationUrlPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\DestinationUrlPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfDestinationUrlPerformanceReportColumn
     */
    public function addToDestinationUrlPerformanceReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\DestinationUrlPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\DestinationUrlPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\DestinationUrlPerformanceReportColumn::getValidValues())), __LINE__);
        }
        $this->DestinationUrlPerformanceReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\DestinationUrlPerformanceReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfDestinationUrlPerformanceReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\DestinationUrlPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\DestinationUrlPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\DestinationUrlPerformanceReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DestinationUrlPerformanceReportColumn
     */
    public function getAttributeName()
    {
        return 'DestinationUrlPerformanceReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDestinationUrlPerformanceReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
