<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGeographicPerformanceReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGeographicPerformanceReportColumn
 * @subpackage Arrays
 */
class ArrayOfGeographicPerformanceReportColumn extends AbstractStructArrayBase
{
    /**
     * The GeographicPerformanceReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $GeographicPerformanceReportColumn;
    /**
     * Constructor method for ArrayOfGeographicPerformanceReportColumn
     * @uses ArrayOfGeographicPerformanceReportColumn::setGeographicPerformanceReportColumn()
     * @param string[] $geographicPerformanceReportColumn
     */
    public function __construct(array $geographicPerformanceReportColumn = array())
    {
        $this
            ->setGeographicPerformanceReportColumn($geographicPerformanceReportColumn);
    }
    /**
     * Get GeographicPerformanceReportColumn value
     * @return string[]|null
     */
    public function getGeographicPerformanceReportColumn()
    {
        return $this->GeographicPerformanceReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setGeographicPerformanceReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGeographicPerformanceReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGeographicPerformanceReportColumnForArrayConstraintsFromSetGeographicPerformanceReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGeographicPerformanceReportColumnGeographicPerformanceReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\GeographicPerformanceReportColumn::valueIsValid($arrayOfGeographicPerformanceReportColumnGeographicPerformanceReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfGeographicPerformanceReportColumnGeographicPerformanceReportColumnItem) ? get_class($arrayOfGeographicPerformanceReportColumnGeographicPerformanceReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfGeographicPerformanceReportColumnGeographicPerformanceReportColumnItem), var_export($arrayOfGeographicPerformanceReportColumnGeographicPerformanceReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\GeographicPerformanceReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\GeographicPerformanceReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GeographicPerformanceReportColumn value
     * @uses \EnumType\GeographicPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\GeographicPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $geographicPerformanceReportColumn
     * @return \ArrayType\ArrayOfGeographicPerformanceReportColumn
     */
    public function setGeographicPerformanceReportColumn(array $geographicPerformanceReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($geographicPerformanceReportColumnArrayErrorMessage = self::validateGeographicPerformanceReportColumnForArrayConstraintsFromSetGeographicPerformanceReportColumn($geographicPerformanceReportColumn))) {
            throw new \InvalidArgumentException($geographicPerformanceReportColumnArrayErrorMessage, __LINE__);
        }
        $this->GeographicPerformanceReportColumn = $geographicPerformanceReportColumn;
        return $this;
    }
    /**
     * Add item to GeographicPerformanceReportColumn value
     * @uses \EnumType\GeographicPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\GeographicPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfGeographicPerformanceReportColumn
     */
    public function addToGeographicPerformanceReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\GeographicPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\GeographicPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\GeographicPerformanceReportColumn::getValidValues())), __LINE__);
        }
        $this->GeographicPerformanceReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\GeographicPerformanceReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfGeographicPerformanceReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\GeographicPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\GeographicPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\GeographicPerformanceReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GeographicPerformanceReportColumn
     */
    public function getAttributeName()
    {
        return 'GeographicPerformanceReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfGeographicPerformanceReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
