<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGoalsAndFunnelsReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGoalsAndFunnelsReportColumn
 * @subpackage Arrays
 */
class ArrayOfGoalsAndFunnelsReportColumn extends AbstractStructArrayBase
{
    /**
     * The GoalsAndFunnelsReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $GoalsAndFunnelsReportColumn;
    /**
     * Constructor method for ArrayOfGoalsAndFunnelsReportColumn
     * @uses ArrayOfGoalsAndFunnelsReportColumn::setGoalsAndFunnelsReportColumn()
     * @param string[] $goalsAndFunnelsReportColumn
     */
    public function __construct(array $goalsAndFunnelsReportColumn = array())
    {
        $this
            ->setGoalsAndFunnelsReportColumn($goalsAndFunnelsReportColumn);
    }
    /**
     * Get GoalsAndFunnelsReportColumn value
     * @return string[]|null
     */
    public function getGoalsAndFunnelsReportColumn()
    {
        return $this->GoalsAndFunnelsReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setGoalsAndFunnelsReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGoalsAndFunnelsReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGoalsAndFunnelsReportColumnForArrayConstraintsFromSetGoalsAndFunnelsReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGoalsAndFunnelsReportColumnGoalsAndFunnelsReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\GoalsAndFunnelsReportColumn::valueIsValid($arrayOfGoalsAndFunnelsReportColumnGoalsAndFunnelsReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfGoalsAndFunnelsReportColumnGoalsAndFunnelsReportColumnItem) ? get_class($arrayOfGoalsAndFunnelsReportColumnGoalsAndFunnelsReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfGoalsAndFunnelsReportColumnGoalsAndFunnelsReportColumnItem), var_export($arrayOfGoalsAndFunnelsReportColumnGoalsAndFunnelsReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\GoalsAndFunnelsReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\GoalsAndFunnelsReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GoalsAndFunnelsReportColumn value
     * @uses \EnumType\GoalsAndFunnelsReportColumn::valueIsValid()
     * @uses \EnumType\GoalsAndFunnelsReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $goalsAndFunnelsReportColumn
     * @return \ArrayType\ArrayOfGoalsAndFunnelsReportColumn
     */
    public function setGoalsAndFunnelsReportColumn(array $goalsAndFunnelsReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($goalsAndFunnelsReportColumnArrayErrorMessage = self::validateGoalsAndFunnelsReportColumnForArrayConstraintsFromSetGoalsAndFunnelsReportColumn($goalsAndFunnelsReportColumn))) {
            throw new \InvalidArgumentException($goalsAndFunnelsReportColumnArrayErrorMessage, __LINE__);
        }
        $this->GoalsAndFunnelsReportColumn = $goalsAndFunnelsReportColumn;
        return $this;
    }
    /**
     * Add item to GoalsAndFunnelsReportColumn value
     * @uses \EnumType\GoalsAndFunnelsReportColumn::valueIsValid()
     * @uses \EnumType\GoalsAndFunnelsReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfGoalsAndFunnelsReportColumn
     */
    public function addToGoalsAndFunnelsReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\GoalsAndFunnelsReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\GoalsAndFunnelsReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\GoalsAndFunnelsReportColumn::getValidValues())), __LINE__);
        }
        $this->GoalsAndFunnelsReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\GoalsAndFunnelsReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfGoalsAndFunnelsReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\GoalsAndFunnelsReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\GoalsAndFunnelsReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\GoalsAndFunnelsReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GoalsAndFunnelsReportColumn
     */
    public function getAttributeName()
    {
        return 'GoalsAndFunnelsReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfGoalsAndFunnelsReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
