<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfKeywordPerformanceReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfKeywordPerformanceReportColumn
 * @subpackage Arrays
 */
class ArrayOfKeywordPerformanceReportColumn extends AbstractStructArrayBase
{
    /**
     * The KeywordPerformanceReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $KeywordPerformanceReportColumn;
    /**
     * Constructor method for ArrayOfKeywordPerformanceReportColumn
     * @uses ArrayOfKeywordPerformanceReportColumn::setKeywordPerformanceReportColumn()
     * @param string[] $keywordPerformanceReportColumn
     */
    public function __construct(array $keywordPerformanceReportColumn = array())
    {
        $this
            ->setKeywordPerformanceReportColumn($keywordPerformanceReportColumn);
    }
    /**
     * Get KeywordPerformanceReportColumn value
     * @return string[]|null
     */
    public function getKeywordPerformanceReportColumn()
    {
        return $this->KeywordPerformanceReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setKeywordPerformanceReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setKeywordPerformanceReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateKeywordPerformanceReportColumnForArrayConstraintsFromSetKeywordPerformanceReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfKeywordPerformanceReportColumnKeywordPerformanceReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\KeywordPerformanceReportColumn::valueIsValid($arrayOfKeywordPerformanceReportColumnKeywordPerformanceReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfKeywordPerformanceReportColumnKeywordPerformanceReportColumnItem) ? get_class($arrayOfKeywordPerformanceReportColumnKeywordPerformanceReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfKeywordPerformanceReportColumnKeywordPerformanceReportColumnItem), var_export($arrayOfKeywordPerformanceReportColumnKeywordPerformanceReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\KeywordPerformanceReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\KeywordPerformanceReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set KeywordPerformanceReportColumn value
     * @uses \EnumType\KeywordPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\KeywordPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $keywordPerformanceReportColumn
     * @return \ArrayType\ArrayOfKeywordPerformanceReportColumn
     */
    public function setKeywordPerformanceReportColumn(array $keywordPerformanceReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($keywordPerformanceReportColumnArrayErrorMessage = self::validateKeywordPerformanceReportColumnForArrayConstraintsFromSetKeywordPerformanceReportColumn($keywordPerformanceReportColumn))) {
            throw new \InvalidArgumentException($keywordPerformanceReportColumnArrayErrorMessage, __LINE__);
        }
        $this->KeywordPerformanceReportColumn = $keywordPerformanceReportColumn;
        return $this;
    }
    /**
     * Add item to KeywordPerformanceReportColumn value
     * @uses \EnumType\KeywordPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\KeywordPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfKeywordPerformanceReportColumn
     */
    public function addToKeywordPerformanceReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\KeywordPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\KeywordPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\KeywordPerformanceReportColumn::getValidValues())), __LINE__);
        }
        $this->KeywordPerformanceReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\KeywordPerformanceReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfKeywordPerformanceReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\KeywordPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\KeywordPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\KeywordPerformanceReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string KeywordPerformanceReportColumn
     */
    public function getAttributeName()
    {
        return 'KeywordPerformanceReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfKeywordPerformanceReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
