<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfKeywordPerformanceReportSort ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfKeywordPerformanceReportSort
 * @subpackage Arrays
 */
class ArrayOfKeywordPerformanceReportSort extends AbstractStructArrayBase
{
    /**
     * The KeywordPerformanceReportSort
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\KeywordPerformanceReportSort[]
     */
    public $KeywordPerformanceReportSort;
    /**
     * Constructor method for ArrayOfKeywordPerformanceReportSort
     * @uses ArrayOfKeywordPerformanceReportSort::setKeywordPerformanceReportSort()
     * @param \StructType\KeywordPerformanceReportSort[] $keywordPerformanceReportSort
     */
    public function __construct(array $keywordPerformanceReportSort = array())
    {
        $this
            ->setKeywordPerformanceReportSort($keywordPerformanceReportSort);
    }
    /**
     * Get KeywordPerformanceReportSort value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\KeywordPerformanceReportSort[]|null
     */
    public function getKeywordPerformanceReportSort()
    {
        return isset($this->KeywordPerformanceReportSort) ? $this->KeywordPerformanceReportSort : null;
    }
    /**
     * This method is responsible for validating the values passed to the setKeywordPerformanceReportSort method
     * This method is willingly generated in order to preserve the one-line inline validation within the setKeywordPerformanceReportSort method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateKeywordPerformanceReportSortForArrayConstraintsFromSetKeywordPerformanceReportSort(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfKeywordPerformanceReportSortKeywordPerformanceReportSortItem) {
            // validation for constraint: itemType
            if (!$arrayOfKeywordPerformanceReportSortKeywordPerformanceReportSortItem instanceof \StructType\KeywordPerformanceReportSort) {
                $invalidValues[] = is_object($arrayOfKeywordPerformanceReportSortKeywordPerformanceReportSortItem) ? get_class($arrayOfKeywordPerformanceReportSortKeywordPerformanceReportSortItem) : sprintf('%s(%s)', gettype($arrayOfKeywordPerformanceReportSortKeywordPerformanceReportSortItem), var_export($arrayOfKeywordPerformanceReportSortKeywordPerformanceReportSortItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The KeywordPerformanceReportSort property can only contain items of type \StructType\KeywordPerformanceReportSort, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set KeywordPerformanceReportSort value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\KeywordPerformanceReportSort[] $keywordPerformanceReportSort
     * @return \ArrayType\ArrayOfKeywordPerformanceReportSort
     */
    public function setKeywordPerformanceReportSort(array $keywordPerformanceReportSort = array())
    {
        // validation for constraint: array
        if ('' !== ($keywordPerformanceReportSortArrayErrorMessage = self::validateKeywordPerformanceReportSortForArrayConstraintsFromSetKeywordPerformanceReportSort($keywordPerformanceReportSort))) {
            throw new \InvalidArgumentException($keywordPerformanceReportSortArrayErrorMessage, __LINE__);
        }
        if (is_null($keywordPerformanceReportSort) || (is_array($keywordPerformanceReportSort) && empty($keywordPerformanceReportSort))) {
            unset($this->KeywordPerformanceReportSort);
        } else {
            $this->KeywordPerformanceReportSort = $keywordPerformanceReportSort;
        }
        return $this;
    }
    /**
     * Add item to KeywordPerformanceReportSort value
     * @throws \InvalidArgumentException
     * @param \StructType\KeywordPerformanceReportSort $item
     * @return \ArrayType\ArrayOfKeywordPerformanceReportSort
     */
    public function addToKeywordPerformanceReportSort(\StructType\KeywordPerformanceReportSort $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\KeywordPerformanceReportSort) {
            throw new \InvalidArgumentException(sprintf('The KeywordPerformanceReportSort property can only contain items of type \StructType\KeywordPerformanceReportSort, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->KeywordPerformanceReportSort[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\KeywordPerformanceReportSort|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\KeywordPerformanceReportSort|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\KeywordPerformanceReportSort|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\KeywordPerformanceReportSort|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\KeywordPerformanceReportSort|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string KeywordPerformanceReportSort
     */
    public function getAttributeName()
    {
        return 'KeywordPerformanceReportSort';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfKeywordPerformanceReportSort
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
