<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfNegativeKeywordConflictReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfNegativeKeywordConflictReportColumn
 * @subpackage Arrays
 */
class ArrayOfNegativeKeywordConflictReportColumn extends AbstractStructArrayBase
{
    /**
     * The NegativeKeywordConflictReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $NegativeKeywordConflictReportColumn;
    /**
     * Constructor method for ArrayOfNegativeKeywordConflictReportColumn
     * @uses ArrayOfNegativeKeywordConflictReportColumn::setNegativeKeywordConflictReportColumn()
     * @param string[] $negativeKeywordConflictReportColumn
     */
    public function __construct(array $negativeKeywordConflictReportColumn = array())
    {
        $this
            ->setNegativeKeywordConflictReportColumn($negativeKeywordConflictReportColumn);
    }
    /**
     * Get NegativeKeywordConflictReportColumn value
     * @return string[]|null
     */
    public function getNegativeKeywordConflictReportColumn()
    {
        return $this->NegativeKeywordConflictReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setNegativeKeywordConflictReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setNegativeKeywordConflictReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateNegativeKeywordConflictReportColumnForArrayConstraintsFromSetNegativeKeywordConflictReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfNegativeKeywordConflictReportColumnNegativeKeywordConflictReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\NegativeKeywordConflictReportColumn::valueIsValid($arrayOfNegativeKeywordConflictReportColumnNegativeKeywordConflictReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfNegativeKeywordConflictReportColumnNegativeKeywordConflictReportColumnItem) ? get_class($arrayOfNegativeKeywordConflictReportColumnNegativeKeywordConflictReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfNegativeKeywordConflictReportColumnNegativeKeywordConflictReportColumnItem), var_export($arrayOfNegativeKeywordConflictReportColumnNegativeKeywordConflictReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\NegativeKeywordConflictReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\NegativeKeywordConflictReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set NegativeKeywordConflictReportColumn value
     * @uses \EnumType\NegativeKeywordConflictReportColumn::valueIsValid()
     * @uses \EnumType\NegativeKeywordConflictReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $negativeKeywordConflictReportColumn
     * @return \ArrayType\ArrayOfNegativeKeywordConflictReportColumn
     */
    public function setNegativeKeywordConflictReportColumn(array $negativeKeywordConflictReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($negativeKeywordConflictReportColumnArrayErrorMessage = self::validateNegativeKeywordConflictReportColumnForArrayConstraintsFromSetNegativeKeywordConflictReportColumn($negativeKeywordConflictReportColumn))) {
            throw new \InvalidArgumentException($negativeKeywordConflictReportColumnArrayErrorMessage, __LINE__);
        }
        $this->NegativeKeywordConflictReportColumn = $negativeKeywordConflictReportColumn;
        return $this;
    }
    /**
     * Add item to NegativeKeywordConflictReportColumn value
     * @uses \EnumType\NegativeKeywordConflictReportColumn::valueIsValid()
     * @uses \EnumType\NegativeKeywordConflictReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfNegativeKeywordConflictReportColumn
     */
    public function addToNegativeKeywordConflictReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\NegativeKeywordConflictReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\NegativeKeywordConflictReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\NegativeKeywordConflictReportColumn::getValidValues())), __LINE__);
        }
        $this->NegativeKeywordConflictReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\NegativeKeywordConflictReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfNegativeKeywordConflictReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\NegativeKeywordConflictReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\NegativeKeywordConflictReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\NegativeKeywordConflictReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string NegativeKeywordConflictReportColumn
     */
    public function getAttributeName()
    {
        return 'NegativeKeywordConflictReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfNegativeKeywordConflictReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
