<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProductDimensionPerformanceReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfProductDimensionPerformanceReportColumn
 * @subpackage Arrays
 */
class ArrayOfProductDimensionPerformanceReportColumn extends AbstractStructArrayBase
{
    /**
     * The ProductDimensionPerformanceReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $ProductDimensionPerformanceReportColumn;
    /**
     * Constructor method for ArrayOfProductDimensionPerformanceReportColumn
     * @uses ArrayOfProductDimensionPerformanceReportColumn::setProductDimensionPerformanceReportColumn()
     * @param string[] $productDimensionPerformanceReportColumn
     */
    public function __construct(array $productDimensionPerformanceReportColumn = array())
    {
        $this
            ->setProductDimensionPerformanceReportColumn($productDimensionPerformanceReportColumn);
    }
    /**
     * Get ProductDimensionPerformanceReportColumn value
     * @return string[]|null
     */
    public function getProductDimensionPerformanceReportColumn()
    {
        return $this->ProductDimensionPerformanceReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setProductDimensionPerformanceReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProductDimensionPerformanceReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProductDimensionPerformanceReportColumnForArrayConstraintsFromSetProductDimensionPerformanceReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfProductDimensionPerformanceReportColumnProductDimensionPerformanceReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\ProductDimensionPerformanceReportColumn::valueIsValid($arrayOfProductDimensionPerformanceReportColumnProductDimensionPerformanceReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfProductDimensionPerformanceReportColumnProductDimensionPerformanceReportColumnItem) ? get_class($arrayOfProductDimensionPerformanceReportColumnProductDimensionPerformanceReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfProductDimensionPerformanceReportColumnProductDimensionPerformanceReportColumnItem), var_export($arrayOfProductDimensionPerformanceReportColumnProductDimensionPerformanceReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\ProductDimensionPerformanceReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\ProductDimensionPerformanceReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ProductDimensionPerformanceReportColumn value
     * @uses \EnumType\ProductDimensionPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\ProductDimensionPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $productDimensionPerformanceReportColumn
     * @return \ArrayType\ArrayOfProductDimensionPerformanceReportColumn
     */
    public function setProductDimensionPerformanceReportColumn(array $productDimensionPerformanceReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($productDimensionPerformanceReportColumnArrayErrorMessage = self::validateProductDimensionPerformanceReportColumnForArrayConstraintsFromSetProductDimensionPerformanceReportColumn($productDimensionPerformanceReportColumn))) {
            throw new \InvalidArgumentException($productDimensionPerformanceReportColumnArrayErrorMessage, __LINE__);
        }
        $this->ProductDimensionPerformanceReportColumn = $productDimensionPerformanceReportColumn;
        return $this;
    }
    /**
     * Add item to ProductDimensionPerformanceReportColumn value
     * @uses \EnumType\ProductDimensionPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\ProductDimensionPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfProductDimensionPerformanceReportColumn
     */
    public function addToProductDimensionPerformanceReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\ProductDimensionPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\ProductDimensionPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\ProductDimensionPerformanceReportColumn::getValidValues())), __LINE__);
        }
        $this->ProductDimensionPerformanceReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\ProductDimensionPerformanceReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfProductDimensionPerformanceReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\ProductDimensionPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\ProductDimensionPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\ProductDimensionPerformanceReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProductDimensionPerformanceReportColumn
     */
    public function getAttributeName()
    {
        return 'ProductDimensionPerformanceReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfProductDimensionPerformanceReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
