<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProductSearchQueryPerformanceReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfProductSearchQueryPerformanceReportColumn
 * @subpackage Arrays
 */
class ArrayOfProductSearchQueryPerformanceReportColumn extends AbstractStructArrayBase
{
    /**
     * The ProductSearchQueryPerformanceReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $ProductSearchQueryPerformanceReportColumn;
    /**
     * Constructor method for ArrayOfProductSearchQueryPerformanceReportColumn
     * @uses ArrayOfProductSearchQueryPerformanceReportColumn::setProductSearchQueryPerformanceReportColumn()
     * @param string[] $productSearchQueryPerformanceReportColumn
     */
    public function __construct(array $productSearchQueryPerformanceReportColumn = array())
    {
        $this
            ->setProductSearchQueryPerformanceReportColumn($productSearchQueryPerformanceReportColumn);
    }
    /**
     * Get ProductSearchQueryPerformanceReportColumn value
     * @return string[]|null
     */
    public function getProductSearchQueryPerformanceReportColumn()
    {
        return $this->ProductSearchQueryPerformanceReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setProductSearchQueryPerformanceReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProductSearchQueryPerformanceReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProductSearchQueryPerformanceReportColumnForArrayConstraintsFromSetProductSearchQueryPerformanceReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfProductSearchQueryPerformanceReportColumnProductSearchQueryPerformanceReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\ProductSearchQueryPerformanceReportColumn::valueIsValid($arrayOfProductSearchQueryPerformanceReportColumnProductSearchQueryPerformanceReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfProductSearchQueryPerformanceReportColumnProductSearchQueryPerformanceReportColumnItem) ? get_class($arrayOfProductSearchQueryPerformanceReportColumnProductSearchQueryPerformanceReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfProductSearchQueryPerformanceReportColumnProductSearchQueryPerformanceReportColumnItem), var_export($arrayOfProductSearchQueryPerformanceReportColumnProductSearchQueryPerformanceReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\ProductSearchQueryPerformanceReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\ProductSearchQueryPerformanceReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ProductSearchQueryPerformanceReportColumn value
     * @uses \EnumType\ProductSearchQueryPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\ProductSearchQueryPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $productSearchQueryPerformanceReportColumn
     * @return \ArrayType\ArrayOfProductSearchQueryPerformanceReportColumn
     */
    public function setProductSearchQueryPerformanceReportColumn(array $productSearchQueryPerformanceReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($productSearchQueryPerformanceReportColumnArrayErrorMessage = self::validateProductSearchQueryPerformanceReportColumnForArrayConstraintsFromSetProductSearchQueryPerformanceReportColumn($productSearchQueryPerformanceReportColumn))) {
            throw new \InvalidArgumentException($productSearchQueryPerformanceReportColumnArrayErrorMessage, __LINE__);
        }
        $this->ProductSearchQueryPerformanceReportColumn = $productSearchQueryPerformanceReportColumn;
        return $this;
    }
    /**
     * Add item to ProductSearchQueryPerformanceReportColumn value
     * @uses \EnumType\ProductSearchQueryPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\ProductSearchQueryPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfProductSearchQueryPerformanceReportColumn
     */
    public function addToProductSearchQueryPerformanceReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\ProductSearchQueryPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\ProductSearchQueryPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\ProductSearchQueryPerformanceReportColumn::getValidValues())), __LINE__);
        }
        $this->ProductSearchQueryPerformanceReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\ProductSearchQueryPerformanceReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfProductSearchQueryPerformanceReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\ProductSearchQueryPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\ProductSearchQueryPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\ProductSearchQueryPerformanceReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProductSearchQueryPerformanceReportColumn
     */
    public function getAttributeName()
    {
        return 'ProductSearchQueryPerformanceReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfProductSearchQueryPerformanceReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
