<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPublisherUsagePerformanceReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPublisherUsagePerformanceReportColumn
 * @subpackage Arrays
 */
class ArrayOfPublisherUsagePerformanceReportColumn extends AbstractStructArrayBase
{
    /**
     * The PublisherUsagePerformanceReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $PublisherUsagePerformanceReportColumn;
    /**
     * Constructor method for ArrayOfPublisherUsagePerformanceReportColumn
     * @uses ArrayOfPublisherUsagePerformanceReportColumn::setPublisherUsagePerformanceReportColumn()
     * @param string[] $publisherUsagePerformanceReportColumn
     */
    public function __construct(array $publisherUsagePerformanceReportColumn = array())
    {
        $this
            ->setPublisherUsagePerformanceReportColumn($publisherUsagePerformanceReportColumn);
    }
    /**
     * Get PublisherUsagePerformanceReportColumn value
     * @return string[]|null
     */
    public function getPublisherUsagePerformanceReportColumn()
    {
        return $this->PublisherUsagePerformanceReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setPublisherUsagePerformanceReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPublisherUsagePerformanceReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePublisherUsagePerformanceReportColumnForArrayConstraintsFromSetPublisherUsagePerformanceReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPublisherUsagePerformanceReportColumnPublisherUsagePerformanceReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\PublisherUsagePerformanceReportColumn::valueIsValid($arrayOfPublisherUsagePerformanceReportColumnPublisherUsagePerformanceReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfPublisherUsagePerformanceReportColumnPublisherUsagePerformanceReportColumnItem) ? get_class($arrayOfPublisherUsagePerformanceReportColumnPublisherUsagePerformanceReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfPublisherUsagePerformanceReportColumnPublisherUsagePerformanceReportColumnItem), var_export($arrayOfPublisherUsagePerformanceReportColumnPublisherUsagePerformanceReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\PublisherUsagePerformanceReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\PublisherUsagePerformanceReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PublisherUsagePerformanceReportColumn value
     * @uses \EnumType\PublisherUsagePerformanceReportColumn::valueIsValid()
     * @uses \EnumType\PublisherUsagePerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $publisherUsagePerformanceReportColumn
     * @return \ArrayType\ArrayOfPublisherUsagePerformanceReportColumn
     */
    public function setPublisherUsagePerformanceReportColumn(array $publisherUsagePerformanceReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($publisherUsagePerformanceReportColumnArrayErrorMessage = self::validatePublisherUsagePerformanceReportColumnForArrayConstraintsFromSetPublisherUsagePerformanceReportColumn($publisherUsagePerformanceReportColumn))) {
            throw new \InvalidArgumentException($publisherUsagePerformanceReportColumnArrayErrorMessage, __LINE__);
        }
        $this->PublisherUsagePerformanceReportColumn = $publisherUsagePerformanceReportColumn;
        return $this;
    }
    /**
     * Add item to PublisherUsagePerformanceReportColumn value
     * @uses \EnumType\PublisherUsagePerformanceReportColumn::valueIsValid()
     * @uses \EnumType\PublisherUsagePerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfPublisherUsagePerformanceReportColumn
     */
    public function addToPublisherUsagePerformanceReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\PublisherUsagePerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\PublisherUsagePerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\PublisherUsagePerformanceReportColumn::getValidValues())), __LINE__);
        }
        $this->PublisherUsagePerformanceReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\PublisherUsagePerformanceReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfPublisherUsagePerformanceReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\PublisherUsagePerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\PublisherUsagePerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\PublisherUsagePerformanceReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PublisherUsagePerformanceReportColumn
     */
    public function getAttributeName()
    {
        return 'PublisherUsagePerformanceReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfPublisherUsagePerformanceReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
