<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSearchCampaignChangeHistoryReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSearchCampaignChangeHistoryReportColumn
 * @subpackage Arrays
 */
class ArrayOfSearchCampaignChangeHistoryReportColumn extends AbstractStructArrayBase
{
    /**
     * The SearchCampaignChangeHistoryReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $SearchCampaignChangeHistoryReportColumn;
    /**
     * Constructor method for ArrayOfSearchCampaignChangeHistoryReportColumn
     * @uses ArrayOfSearchCampaignChangeHistoryReportColumn::setSearchCampaignChangeHistoryReportColumn()
     * @param string[] $searchCampaignChangeHistoryReportColumn
     */
    public function __construct(array $searchCampaignChangeHistoryReportColumn = array())
    {
        $this
            ->setSearchCampaignChangeHistoryReportColumn($searchCampaignChangeHistoryReportColumn);
    }
    /**
     * Get SearchCampaignChangeHistoryReportColumn value
     * @return string[]|null
     */
    public function getSearchCampaignChangeHistoryReportColumn()
    {
        return $this->SearchCampaignChangeHistoryReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setSearchCampaignChangeHistoryReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSearchCampaignChangeHistoryReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSearchCampaignChangeHistoryReportColumnForArrayConstraintsFromSetSearchCampaignChangeHistoryReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSearchCampaignChangeHistoryReportColumnSearchCampaignChangeHistoryReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\SearchCampaignChangeHistoryReportColumn::valueIsValid($arrayOfSearchCampaignChangeHistoryReportColumnSearchCampaignChangeHistoryReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfSearchCampaignChangeHistoryReportColumnSearchCampaignChangeHistoryReportColumnItem) ? get_class($arrayOfSearchCampaignChangeHistoryReportColumnSearchCampaignChangeHistoryReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfSearchCampaignChangeHistoryReportColumnSearchCampaignChangeHistoryReportColumnItem), var_export($arrayOfSearchCampaignChangeHistoryReportColumnSearchCampaignChangeHistoryReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\SearchCampaignChangeHistoryReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\SearchCampaignChangeHistoryReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SearchCampaignChangeHistoryReportColumn value
     * @uses \EnumType\SearchCampaignChangeHistoryReportColumn::valueIsValid()
     * @uses \EnumType\SearchCampaignChangeHistoryReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $searchCampaignChangeHistoryReportColumn
     * @return \ArrayType\ArrayOfSearchCampaignChangeHistoryReportColumn
     */
    public function setSearchCampaignChangeHistoryReportColumn(array $searchCampaignChangeHistoryReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($searchCampaignChangeHistoryReportColumnArrayErrorMessage = self::validateSearchCampaignChangeHistoryReportColumnForArrayConstraintsFromSetSearchCampaignChangeHistoryReportColumn($searchCampaignChangeHistoryReportColumn))) {
            throw new \InvalidArgumentException($searchCampaignChangeHistoryReportColumnArrayErrorMessage, __LINE__);
        }
        $this->SearchCampaignChangeHistoryReportColumn = $searchCampaignChangeHistoryReportColumn;
        return $this;
    }
    /**
     * Add item to SearchCampaignChangeHistoryReportColumn value
     * @uses \EnumType\SearchCampaignChangeHistoryReportColumn::valueIsValid()
     * @uses \EnumType\SearchCampaignChangeHistoryReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfSearchCampaignChangeHistoryReportColumn
     */
    public function addToSearchCampaignChangeHistoryReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\SearchCampaignChangeHistoryReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\SearchCampaignChangeHistoryReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\SearchCampaignChangeHistoryReportColumn::getValidValues())), __LINE__);
        }
        $this->SearchCampaignChangeHistoryReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\SearchCampaignChangeHistoryReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfSearchCampaignChangeHistoryReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\SearchCampaignChangeHistoryReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\SearchCampaignChangeHistoryReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\SearchCampaignChangeHistoryReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SearchCampaignChangeHistoryReportColumn
     */
    public function getAttributeName()
    {
        return 'SearchCampaignChangeHistoryReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfSearchCampaignChangeHistoryReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
