<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSearchQueryPerformanceReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSearchQueryPerformanceReportColumn
 * @subpackage Arrays
 */
class ArrayOfSearchQueryPerformanceReportColumn extends AbstractStructArrayBase
{
    /**
     * The SearchQueryPerformanceReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $SearchQueryPerformanceReportColumn;
    /**
     * Constructor method for ArrayOfSearchQueryPerformanceReportColumn
     * @uses ArrayOfSearchQueryPerformanceReportColumn::setSearchQueryPerformanceReportColumn()
     * @param string[] $searchQueryPerformanceReportColumn
     */
    public function __construct(array $searchQueryPerformanceReportColumn = array())
    {
        $this
            ->setSearchQueryPerformanceReportColumn($searchQueryPerformanceReportColumn);
    }
    /**
     * Get SearchQueryPerformanceReportColumn value
     * @return string[]|null
     */
    public function getSearchQueryPerformanceReportColumn()
    {
        return $this->SearchQueryPerformanceReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setSearchQueryPerformanceReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSearchQueryPerformanceReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSearchQueryPerformanceReportColumnForArrayConstraintsFromSetSearchQueryPerformanceReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSearchQueryPerformanceReportColumnSearchQueryPerformanceReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\SearchQueryPerformanceReportColumn::valueIsValid($arrayOfSearchQueryPerformanceReportColumnSearchQueryPerformanceReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfSearchQueryPerformanceReportColumnSearchQueryPerformanceReportColumnItem) ? get_class($arrayOfSearchQueryPerformanceReportColumnSearchQueryPerformanceReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfSearchQueryPerformanceReportColumnSearchQueryPerformanceReportColumnItem), var_export($arrayOfSearchQueryPerformanceReportColumnSearchQueryPerformanceReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\SearchQueryPerformanceReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\SearchQueryPerformanceReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SearchQueryPerformanceReportColumn value
     * @uses \EnumType\SearchQueryPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\SearchQueryPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $searchQueryPerformanceReportColumn
     * @return \ArrayType\ArrayOfSearchQueryPerformanceReportColumn
     */
    public function setSearchQueryPerformanceReportColumn(array $searchQueryPerformanceReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($searchQueryPerformanceReportColumnArrayErrorMessage = self::validateSearchQueryPerformanceReportColumnForArrayConstraintsFromSetSearchQueryPerformanceReportColumn($searchQueryPerformanceReportColumn))) {
            throw new \InvalidArgumentException($searchQueryPerformanceReportColumnArrayErrorMessage, __LINE__);
        }
        $this->SearchQueryPerformanceReportColumn = $searchQueryPerformanceReportColumn;
        return $this;
    }
    /**
     * Add item to SearchQueryPerformanceReportColumn value
     * @uses \EnumType\SearchQueryPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\SearchQueryPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfSearchQueryPerformanceReportColumn
     */
    public function addToSearchQueryPerformanceReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\SearchQueryPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\SearchQueryPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\SearchQueryPerformanceReportColumn::getValidValues())), __LINE__);
        }
        $this->SearchQueryPerformanceReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\SearchQueryPerformanceReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfSearchQueryPerformanceReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\SearchQueryPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\SearchQueryPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\SearchQueryPerformanceReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SearchQueryPerformanceReportColumn
     */
    public function getAttributeName()
    {
        return 'SearchQueryPerformanceReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfSearchQueryPerformanceReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
