<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfShareOfVoiceReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfShareOfVoiceReportColumn
 * @subpackage Arrays
 */
class ArrayOfShareOfVoiceReportColumn extends AbstractStructArrayBase
{
    /**
     * The ShareOfVoiceReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $ShareOfVoiceReportColumn;
    /**
     * Constructor method for ArrayOfShareOfVoiceReportColumn
     * @uses ArrayOfShareOfVoiceReportColumn::setShareOfVoiceReportColumn()
     * @param string[] $shareOfVoiceReportColumn
     */
    public function __construct(array $shareOfVoiceReportColumn = array())
    {
        $this
            ->setShareOfVoiceReportColumn($shareOfVoiceReportColumn);
    }
    /**
     * Get ShareOfVoiceReportColumn value
     * @return string[]|null
     */
    public function getShareOfVoiceReportColumn()
    {
        return $this->ShareOfVoiceReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setShareOfVoiceReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setShareOfVoiceReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateShareOfVoiceReportColumnForArrayConstraintsFromSetShareOfVoiceReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfShareOfVoiceReportColumnShareOfVoiceReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\ShareOfVoiceReportColumn::valueIsValid($arrayOfShareOfVoiceReportColumnShareOfVoiceReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfShareOfVoiceReportColumnShareOfVoiceReportColumnItem) ? get_class($arrayOfShareOfVoiceReportColumnShareOfVoiceReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfShareOfVoiceReportColumnShareOfVoiceReportColumnItem), var_export($arrayOfShareOfVoiceReportColumnShareOfVoiceReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\ShareOfVoiceReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\ShareOfVoiceReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ShareOfVoiceReportColumn value
     * @uses \EnumType\ShareOfVoiceReportColumn::valueIsValid()
     * @uses \EnumType\ShareOfVoiceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $shareOfVoiceReportColumn
     * @return \ArrayType\ArrayOfShareOfVoiceReportColumn
     */
    public function setShareOfVoiceReportColumn(array $shareOfVoiceReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($shareOfVoiceReportColumnArrayErrorMessage = self::validateShareOfVoiceReportColumnForArrayConstraintsFromSetShareOfVoiceReportColumn($shareOfVoiceReportColumn))) {
            throw new \InvalidArgumentException($shareOfVoiceReportColumnArrayErrorMessage, __LINE__);
        }
        $this->ShareOfVoiceReportColumn = $shareOfVoiceReportColumn;
        return $this;
    }
    /**
     * Add item to ShareOfVoiceReportColumn value
     * @uses \EnumType\ShareOfVoiceReportColumn::valueIsValid()
     * @uses \EnumType\ShareOfVoiceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfShareOfVoiceReportColumn
     */
    public function addToShareOfVoiceReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\ShareOfVoiceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\ShareOfVoiceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\ShareOfVoiceReportColumn::getValidValues())), __LINE__);
        }
        $this->ShareOfVoiceReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\ShareOfVoiceReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfShareOfVoiceReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\ShareOfVoiceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\ShareOfVoiceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\ShareOfVoiceReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ShareOfVoiceReportColumn
     */
    public function getAttributeName()
    {
        return 'ShareOfVoiceReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfShareOfVoiceReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
