<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUserLocationPerformanceReportColumn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUserLocationPerformanceReportColumn
 * @subpackage Arrays
 */
class ArrayOfUserLocationPerformanceReportColumn extends AbstractStructArrayBase
{
    /**
     * The UserLocationPerformanceReportColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $UserLocationPerformanceReportColumn;
    /**
     * Constructor method for ArrayOfUserLocationPerformanceReportColumn
     * @uses ArrayOfUserLocationPerformanceReportColumn::setUserLocationPerformanceReportColumn()
     * @param string[] $userLocationPerformanceReportColumn
     */
    public function __construct(array $userLocationPerformanceReportColumn = array())
    {
        $this
            ->setUserLocationPerformanceReportColumn($userLocationPerformanceReportColumn);
    }
    /**
     * Get UserLocationPerformanceReportColumn value
     * @return string[]|null
     */
    public function getUserLocationPerformanceReportColumn()
    {
        return $this->UserLocationPerformanceReportColumn;
    }
    /**
     * This method is responsible for validating the values passed to the setUserLocationPerformanceReportColumn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUserLocationPerformanceReportColumn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUserLocationPerformanceReportColumnForArrayConstraintsFromSetUserLocationPerformanceReportColumn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUserLocationPerformanceReportColumnUserLocationPerformanceReportColumnItem) {
            // validation for constraint: enumeration
            if (!\EnumType\UserLocationPerformanceReportColumn::valueIsValid($arrayOfUserLocationPerformanceReportColumnUserLocationPerformanceReportColumnItem)) {
                $invalidValues[] = is_object($arrayOfUserLocationPerformanceReportColumnUserLocationPerformanceReportColumnItem) ? get_class($arrayOfUserLocationPerformanceReportColumnUserLocationPerformanceReportColumnItem) : sprintf('%s(%s)', gettype($arrayOfUserLocationPerformanceReportColumnUserLocationPerformanceReportColumnItem), var_export($arrayOfUserLocationPerformanceReportColumnUserLocationPerformanceReportColumnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\UserLocationPerformanceReportColumn', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\UserLocationPerformanceReportColumn::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UserLocationPerformanceReportColumn value
     * @uses \EnumType\UserLocationPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\UserLocationPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $userLocationPerformanceReportColumn
     * @return \ArrayType\ArrayOfUserLocationPerformanceReportColumn
     */
    public function setUserLocationPerformanceReportColumn(array $userLocationPerformanceReportColumn = array())
    {
        // validation for constraint: array
        if ('' !== ($userLocationPerformanceReportColumnArrayErrorMessage = self::validateUserLocationPerformanceReportColumnForArrayConstraintsFromSetUserLocationPerformanceReportColumn($userLocationPerformanceReportColumn))) {
            throw new \InvalidArgumentException($userLocationPerformanceReportColumnArrayErrorMessage, __LINE__);
        }
        $this->UserLocationPerformanceReportColumn = $userLocationPerformanceReportColumn;
        return $this;
    }
    /**
     * Add item to UserLocationPerformanceReportColumn value
     * @uses \EnumType\UserLocationPerformanceReportColumn::valueIsValid()
     * @uses \EnumType\UserLocationPerformanceReportColumn::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfUserLocationPerformanceReportColumn
     */
    public function addToUserLocationPerformanceReportColumn($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\UserLocationPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\UserLocationPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\UserLocationPerformanceReportColumn::getValidValues())), __LINE__);
        }
        $this->UserLocationPerformanceReportColumn[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\UserLocationPerformanceReportColumn::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfUserLocationPerformanceReportColumn
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\UserLocationPerformanceReportColumn::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\UserLocationPerformanceReportColumn', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\UserLocationPerformanceReportColumn::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UserLocationPerformanceReportColumn
     */
    public function getAttributeName()
    {
        return 'UserLocationPerformanceReportColumn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfUserLocationPerformanceReportColumn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
