<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'SubmitGenerateReportRequest' => '\\StructType\\SubmitGenerateReportRequest',
            'ReportRequest' => '\\StructType\\ReportRequest',
            'AccountPerformanceReportRequest' => '\\StructType\\AccountPerformanceReportRequest',
            'ArrayOfAccountPerformanceReportColumn' => '\\ArrayType\\ArrayOfAccountPerformanceReportColumn',
            'AccountPerformanceReportFilter' => '\\StructType\\AccountPerformanceReportFilter',
            'AccountReportScope' => '\\StructType\\AccountReportScope',
            'ReportTime' => '\\StructType\\ReportTime',
            'Date' => '\\StructType\\Date',
            'CampaignPerformanceReportRequest' => '\\StructType\\CampaignPerformanceReportRequest',
            'ArrayOfCampaignPerformanceReportColumn' => '\\ArrayType\\ArrayOfCampaignPerformanceReportColumn',
            'CampaignPerformanceReportFilter' => '\\StructType\\CampaignPerformanceReportFilter',
            'AccountThroughCampaignReportScope' => '\\StructType\\AccountThroughCampaignReportScope',
            'ArrayOfCampaignReportScope' => '\\ArrayType\\ArrayOfCampaignReportScope',
            'CampaignReportScope' => '\\StructType\\CampaignReportScope',
            'AdDynamicTextPerformanceReportRequest' => '\\StructType\\AdDynamicTextPerformanceReportRequest',
            'ArrayOfAdDynamicTextPerformanceReportColumn' => '\\ArrayType\\ArrayOfAdDynamicTextPerformanceReportColumn',
            'AdDynamicTextPerformanceReportFilter' => '\\StructType\\AdDynamicTextPerformanceReportFilter',
            'AccountThroughAdGroupReportScope' => '\\StructType\\AccountThroughAdGroupReportScope',
            'ArrayOfAdGroupReportScope' => '\\ArrayType\\ArrayOfAdGroupReportScope',
            'AdGroupReportScope' => '\\StructType\\AdGroupReportScope',
            'AdGroupPerformanceReportRequest' => '\\StructType\\AdGroupPerformanceReportRequest',
            'ArrayOfAdGroupPerformanceReportColumn' => '\\ArrayType\\ArrayOfAdGroupPerformanceReportColumn',
            'AdGroupPerformanceReportFilter' => '\\StructType\\AdGroupPerformanceReportFilter',
            'AdPerformanceReportRequest' => '\\StructType\\AdPerformanceReportRequest',
            'ArrayOfAdPerformanceReportColumn' => '\\ArrayType\\ArrayOfAdPerformanceReportColumn',
            'AdPerformanceReportFilter' => '\\StructType\\AdPerformanceReportFilter',
            'KeywordPerformanceReportRequest' => '\\StructType\\KeywordPerformanceReportRequest',
            'ArrayOfKeywordPerformanceReportColumn' => '\\ArrayType\\ArrayOfKeywordPerformanceReportColumn',
            'KeywordPerformanceReportFilter' => '\\StructType\\KeywordPerformanceReportFilter',
            'ArrayOfKeywordPerformanceReportSort' => '\\ArrayType\\ArrayOfKeywordPerformanceReportSort',
            'KeywordPerformanceReportSort' => '\\StructType\\KeywordPerformanceReportSort',
            'DestinationUrlPerformanceReportRequest' => '\\StructType\\DestinationUrlPerformanceReportRequest',
            'ArrayOfDestinationUrlPerformanceReportColumn' => '\\ArrayType\\ArrayOfDestinationUrlPerformanceReportColumn',
            'DestinationUrlPerformanceReportFilter' => '\\StructType\\DestinationUrlPerformanceReportFilter',
            'BudgetSummaryReportRequest' => '\\StructType\\BudgetSummaryReportRequest',
            'ArrayOfBudgetSummaryReportColumn' => '\\ArrayType\\ArrayOfBudgetSummaryReportColumn',
            'AgeGenderAudienceReportRequest' => '\\StructType\\AgeGenderAudienceReportRequest',
            'ArrayOfAgeGenderAudienceReportColumn' => '\\ArrayType\\ArrayOfAgeGenderAudienceReportColumn',
            'AgeGenderAudienceReportFilter' => '\\StructType\\AgeGenderAudienceReportFilter',
            'ProfessionalDemographicsAudienceReportRequest' => '\\StructType\\ProfessionalDemographicsAudienceReportRequest',
            'ArrayOfProfessionalDemographicsAudienceReportColumn' => '\\ArrayType\\ArrayOfProfessionalDemographicsAudienceReportColumn',
            'ProfessionalDemographicsAudienceReportFilter' => '\\StructType\\ProfessionalDemographicsAudienceReportFilter',
            'UserLocationPerformanceReportRequest' => '\\StructType\\UserLocationPerformanceReportRequest',
            'ArrayOfUserLocationPerformanceReportColumn' => '\\ArrayType\\ArrayOfUserLocationPerformanceReportColumn',
            'UserLocationPerformanceReportFilter' => '\\StructType\\UserLocationPerformanceReportFilter',
            'PublisherUsagePerformanceReportRequest' => '\\StructType\\PublisherUsagePerformanceReportRequest',
            'ArrayOfPublisherUsagePerformanceReportColumn' => '\\ArrayType\\ArrayOfPublisherUsagePerformanceReportColumn',
            'PublisherUsagePerformanceReportFilter' => '\\StructType\\PublisherUsagePerformanceReportFilter',
            'SearchQueryPerformanceReportRequest' => '\\StructType\\SearchQueryPerformanceReportRequest',
            'ArrayOfSearchQueryPerformanceReportColumn' => '\\ArrayType\\ArrayOfSearchQueryPerformanceReportColumn',
            'SearchQueryPerformanceReportFilter' => '\\StructType\\SearchQueryPerformanceReportFilter',
            'ConversionPerformanceReportRequest' => '\\StructType\\ConversionPerformanceReportRequest',
            'ArrayOfConversionPerformanceReportColumn' => '\\ArrayType\\ArrayOfConversionPerformanceReportColumn',
            'ConversionPerformanceReportFilter' => '\\StructType\\ConversionPerformanceReportFilter',
            'GoalsAndFunnelsReportRequest' => '\\StructType\\GoalsAndFunnelsReportRequest',
            'ArrayOfGoalsAndFunnelsReportColumn' => '\\ArrayType\\ArrayOfGoalsAndFunnelsReportColumn',
            'GoalsAndFunnelsReportFilter' => '\\StructType\\GoalsAndFunnelsReportFilter',
            'NegativeKeywordConflictReportRequest' => '\\StructType\\NegativeKeywordConflictReportRequest',
            'ArrayOfNegativeKeywordConflictReportColumn' => '\\ArrayType\\ArrayOfNegativeKeywordConflictReportColumn',
            'NegativeKeywordConflictReportFilter' => '\\StructType\\NegativeKeywordConflictReportFilter',
            'SearchCampaignChangeHistoryReportRequest' => '\\StructType\\SearchCampaignChangeHistoryReportRequest',
            'ArrayOfSearchCampaignChangeHistoryReportColumn' => '\\ArrayType\\ArrayOfSearchCampaignChangeHistoryReportColumn',
            'SearchCampaignChangeHistoryReportFilter' => '\\StructType\\SearchCampaignChangeHistoryReportFilter',
            'AdExtensionByAdReportRequest' => '\\StructType\\AdExtensionByAdReportRequest',
            'ArrayOfAdExtensionByAdReportColumn' => '\\ArrayType\\ArrayOfAdExtensionByAdReportColumn',
            'AdExtensionByAdReportFilter' => '\\StructType\\AdExtensionByAdReportFilter',
            'AdExtensionByKeywordReportRequest' => '\\StructType\\AdExtensionByKeywordReportRequest',
            'ArrayOfAdExtensionByKeywordReportColumn' => '\\ArrayType\\ArrayOfAdExtensionByKeywordReportColumn',
            'AdExtensionByKeywordReportFilter' => '\\StructType\\AdExtensionByKeywordReportFilter',
            'AudiencePerformanceReportRequest' => '\\StructType\\AudiencePerformanceReportRequest',
            'ArrayOfAudiencePerformanceReportColumn' => '\\ArrayType\\ArrayOfAudiencePerformanceReportColumn',
            'AudiencePerformanceReportFilter' => '\\StructType\\AudiencePerformanceReportFilter',
            'AdExtensionDetailReportRequest' => '\\StructType\\AdExtensionDetailReportRequest',
            'ArrayOfAdExtensionDetailReportColumn' => '\\ArrayType\\ArrayOfAdExtensionDetailReportColumn',
            'AdExtensionDetailReportFilter' => '\\StructType\\AdExtensionDetailReportFilter',
            'ShareOfVoiceReportRequest' => '\\StructType\\ShareOfVoiceReportRequest',
            'ArrayOfShareOfVoiceReportColumn' => '\\ArrayType\\ArrayOfShareOfVoiceReportColumn',
            'ShareOfVoiceReportFilter' => '\\StructType\\ShareOfVoiceReportFilter',
            'ProductDimensionPerformanceReportRequest' => '\\StructType\\ProductDimensionPerformanceReportRequest',
            'ArrayOfProductDimensionPerformanceReportColumn' => '\\ArrayType\\ArrayOfProductDimensionPerformanceReportColumn',
            'ProductDimensionPerformanceReportFilter' => '\\StructType\\ProductDimensionPerformanceReportFilter',
            'ProductPartitionPerformanceReportRequest' => '\\StructType\\ProductPartitionPerformanceReportRequest',
            'ArrayOfProductPartitionPerformanceReportColumn' => '\\ArrayType\\ArrayOfProductPartitionPerformanceReportColumn',
            'ProductPartitionPerformanceReportFilter' => '\\StructType\\ProductPartitionPerformanceReportFilter',
            'ProductPartitionUnitPerformanceReportRequest' => '\\StructType\\ProductPartitionUnitPerformanceReportRequest',
            'ArrayOfProductPartitionUnitPerformanceReportColumn' => '\\ArrayType\\ArrayOfProductPartitionUnitPerformanceReportColumn',
            'ProductPartitionUnitPerformanceReportFilter' => '\\StructType\\ProductPartitionUnitPerformanceReportFilter',
            'ProductSearchQueryPerformanceReportRequest' => '\\StructType\\ProductSearchQueryPerformanceReportRequest',
            'ArrayOfProductSearchQueryPerformanceReportColumn' => '\\ArrayType\\ArrayOfProductSearchQueryPerformanceReportColumn',
            'ProductSearchQueryPerformanceReportFilter' => '\\StructType\\ProductSearchQueryPerformanceReportFilter',
            'ProductMatchCountReportRequest' => '\\StructType\\ProductMatchCountReportRequest',
            'ArrayOfProductMatchCountReportColumn' => '\\ArrayType\\ArrayOfProductMatchCountReportColumn',
            'ProductNegativeKeywordConflictReportRequest' => '\\StructType\\ProductNegativeKeywordConflictReportRequest',
            'ArrayOfProductNegativeKeywordConflictReportColumn' => '\\ArrayType\\ArrayOfProductNegativeKeywordConflictReportColumn',
            'ProductNegativeKeywordConflictReportFilter' => '\\StructType\\ProductNegativeKeywordConflictReportFilter',
            'CallDetailReportRequest' => '\\StructType\\CallDetailReportRequest',
            'ArrayOfCallDetailReportColumn' => '\\ArrayType\\ArrayOfCallDetailReportColumn',
            'CallDetailReportFilter' => '\\StructType\\CallDetailReportFilter',
            'GeographicPerformanceReportRequest' => '\\StructType\\GeographicPerformanceReportRequest',
            'ArrayOfGeographicPerformanceReportColumn' => '\\ArrayType\\ArrayOfGeographicPerformanceReportColumn',
            'GeographicPerformanceReportFilter' => '\\StructType\\GeographicPerformanceReportFilter',
            'DSASearchQueryPerformanceReportRequest' => '\\StructType\\DSASearchQueryPerformanceReportRequest',
            'ArrayOfDSASearchQueryPerformanceReportColumn' => '\\ArrayType\\ArrayOfDSASearchQueryPerformanceReportColumn',
            'DSASearchQueryPerformanceReportFilter' => '\\StructType\\DSASearchQueryPerformanceReportFilter',
            'DSAAutoTargetPerformanceReportRequest' => '\\StructType\\DSAAutoTargetPerformanceReportRequest',
            'ArrayOfDSAAutoTargetPerformanceReportColumn' => '\\ArrayType\\ArrayOfDSAAutoTargetPerformanceReportColumn',
            'DSAAutoTargetPerformanceReportFilter' => '\\StructType\\DSAAutoTargetPerformanceReportFilter',
            'DSACategoryPerformanceReportRequest' => '\\StructType\\DSACategoryPerformanceReportRequest',
            'ArrayOfDSACategoryPerformanceReportColumn' => '\\ArrayType\\ArrayOfDSACategoryPerformanceReportColumn',
            'DSACategoryPerformanceReportFilter' => '\\StructType\\DSACategoryPerformanceReportFilter',
            'SubmitGenerateReportResponse' => '\\StructType\\SubmitGenerateReportResponse',
            'ApiFaultDetail' => '\\StructType\\ApiFaultDetail',
            'ArrayOfBatchError' => '\\ArrayType\\ArrayOfBatchError',
            'BatchError' => '\\StructType\\BatchError',
            'ArrayOfOperationError' => '\\ArrayType\\ArrayOfOperationError',
            'OperationError' => '\\StructType\\OperationError',
            'PollGenerateReportRequest' => '\\StructType\\PollGenerateReportRequest',
            'PollGenerateReportResponse' => '\\StructType\\PollGenerateReportResponse',
            'ReportRequestStatus' => '\\StructType\\ReportRequestStatus',
            'ArrayOflong' => '\\ArrayType\\ArrayOflong',
            'ArrayOfint' => '\\ArrayType\\ArrayOfint',
            'ArrayOfstring' => '\\ArrayType\\ArrayOfstring',
            'AdApiFaultDetail' => '\\StructType\\AdApiFaultDetail',
            'ApplicationFault' => '\\StructType\\ApplicationFault',
            'ArrayOfAdApiError' => '\\ArrayType\\ArrayOfAdApiError',
            'AdApiError' => '\\StructType\\AdApiError',
        );
    }
}
