<?php

namespace EnumType;

/**
 * This class stands for AdDistributionReportFilter EnumType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:AdDistributionReportFilter
 * @subpackage Enumerations
 */
class AdDistributionReportFilter
{
    /**
     * Constant for value 'Search'
     * @return string 'Search'
     */
    const VALUE_SEARCH = 'Search';
    /**
     * Constant for value 'Audience'
     * @return string 'Audience'
     */
    const VALUE_AUDIENCE = 'Audience';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_SEARCH
     * @uses self::VALUE_AUDIENCE
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_SEARCH,
            self::VALUE_AUDIENCE,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
