<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AccountReportScope StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:AccountReportScope
 * @subpackage Structs
 */
class AccountReportScope extends AbstractStructBase
{
    /**
     * The AccountIds
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOflong
     */
    public $AccountIds;
    /**
     * Constructor method for AccountReportScope
     * @uses AccountReportScope::setAccountIds()
     * @param \ArrayType\ArrayOflong $accountIds
     */
    public function __construct(\ArrayType\ArrayOflong $accountIds = null)
    {
        $this
            ->setAccountIds($accountIds);
    }
    /**
     * Get AccountIds value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOflong|null
     */
    public function getAccountIds()
    {
        return isset($this->AccountIds) ? $this->AccountIds : null;
    }
    /**
     * Set AccountIds value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOflong $accountIds
     * @return \StructType\AccountReportScope
     */
    public function setAccountIds(\ArrayType\ArrayOflong $accountIds = null)
    {
        if (is_null($accountIds) || (is_array($accountIds) && empty($accountIds))) {
            unset($this->AccountIds);
        } else {
            $this->AccountIds = $accountIds;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AccountReportScope
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
