<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SearchCampaignChangeHistoryReportFilter StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SearchCampaignChangeHistoryReportFilter
 * @subpackage Structs
 */
class SearchCampaignChangeHistoryReportFilter extends AbstractStructBase
{
    /**
     * The AdDistribution
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string[]
     */
    public $AdDistribution;
    /**
     * The HowChanged
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string[]
     */
    public $HowChanged;
    /**
     * The ItemChanged
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string[]
     */
    public $ItemChanged;
    /**
     * Constructor method for SearchCampaignChangeHistoryReportFilter
     * @uses SearchCampaignChangeHistoryReportFilter::setAdDistribution()
     * @uses SearchCampaignChangeHistoryReportFilter::setHowChanged()
     * @uses SearchCampaignChangeHistoryReportFilter::setItemChanged()
     * @param string[] $adDistribution
     * @param string[] $howChanged
     * @param string[] $itemChanged
     */
    public function __construct(array $adDistribution = array(), array $howChanged = array(), array $itemChanged = array())
    {
        $this
            ->setAdDistribution($adDistribution)
            ->setHowChanged($howChanged)
            ->setItemChanged($itemChanged);
    }
    /**
     * Get AdDistribution value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string[]|null
     */
    public function getAdDistribution()
    {
        return isset($this->AdDistribution) ? $this->AdDistribution : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAdDistribution method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdDistribution method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdDistributionForArrayConstraintsFromSetAdDistribution(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $searchCampaignChangeHistoryReportFilterAdDistributionItem) {
            // validation for constraint: enumeration
            if (!\EnumType\AdDistributionReportFilter::valueIsValid($searchCampaignChangeHistoryReportFilterAdDistributionItem)) {
                $invalidValues[] = is_object($searchCampaignChangeHistoryReportFilterAdDistributionItem) ? get_class($searchCampaignChangeHistoryReportFilterAdDistributionItem) : sprintf('%s(%s)', gettype($searchCampaignChangeHistoryReportFilterAdDistributionItem), var_export($searchCampaignChangeHistoryReportFilterAdDistributionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AdDistributionReportFilter', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\AdDistributionReportFilter::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdDistribution value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @uses \EnumType\AdDistributionReportFilter::valueIsValid()
     * @uses \EnumType\AdDistributionReportFilter::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $adDistribution
     * @return \StructType\SearchCampaignChangeHistoryReportFilter
     */
    public function setAdDistribution(array $adDistribution = array())
    {
        // validation for constraint: list
        if ('' !== ($adDistributionArrayErrorMessage = self::validateAdDistributionForArrayConstraintsFromSetAdDistribution($adDistribution))) {
            throw new \InvalidArgumentException($adDistributionArrayErrorMessage, __LINE__);
        }
        if (is_null($adDistribution) || (is_array($adDistribution) && empty($adDistribution))) {
            unset($this->AdDistribution);
        } else {
            $this->AdDistribution = is_array($adDistribution) ? implode(' ', $adDistribution) : null;
        }
        return $this;
    }
    /**
     * Get HowChanged value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string[]|null
     */
    public function getHowChanged()
    {
        return isset($this->HowChanged) ? $this->HowChanged : null;
    }
    /**
     * This method is responsible for validating the values passed to the setHowChanged method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHowChanged method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHowChangedForArrayConstraintsFromSetHowChanged(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $searchCampaignChangeHistoryReportFilterHowChangedItem) {
            // validation for constraint: enumeration
            if (!\EnumType\ChangeTypeReportFilter::valueIsValid($searchCampaignChangeHistoryReportFilterHowChangedItem)) {
                $invalidValues[] = is_object($searchCampaignChangeHistoryReportFilterHowChangedItem) ? get_class($searchCampaignChangeHistoryReportFilterHowChangedItem) : sprintf('%s(%s)', gettype($searchCampaignChangeHistoryReportFilterHowChangedItem), var_export($searchCampaignChangeHistoryReportFilterHowChangedItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\ChangeTypeReportFilter', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\ChangeTypeReportFilter::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set HowChanged value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @uses \EnumType\ChangeTypeReportFilter::valueIsValid()
     * @uses \EnumType\ChangeTypeReportFilter::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $howChanged
     * @return \StructType\SearchCampaignChangeHistoryReportFilter
     */
    public function setHowChanged(array $howChanged = array())
    {
        // validation for constraint: list
        if ('' !== ($howChangedArrayErrorMessage = self::validateHowChangedForArrayConstraintsFromSetHowChanged($howChanged))) {
            throw new \InvalidArgumentException($howChangedArrayErrorMessage, __LINE__);
        }
        if (is_null($howChanged) || (is_array($howChanged) && empty($howChanged))) {
            unset($this->HowChanged);
        } else {
            $this->HowChanged = is_array($howChanged) ? implode(' ', $howChanged) : null;
        }
        return $this;
    }
    /**
     * Get ItemChanged value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string[]|null
     */
    public function getItemChanged()
    {
        return isset($this->ItemChanged) ? $this->ItemChanged : null;
    }
    /**
     * This method is responsible for validating the values passed to the setItemChanged method
     * This method is willingly generated in order to preserve the one-line inline validation within the setItemChanged method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateItemChangedForArrayConstraintsFromSetItemChanged(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $searchCampaignChangeHistoryReportFilterItemChangedItem) {
            // validation for constraint: enumeration
            if (!\EnumType\ChangeEntityReportFilter::valueIsValid($searchCampaignChangeHistoryReportFilterItemChangedItem)) {
                $invalidValues[] = is_object($searchCampaignChangeHistoryReportFilterItemChangedItem) ? get_class($searchCampaignChangeHistoryReportFilterItemChangedItem) : sprintf('%s(%s)', gettype($searchCampaignChangeHistoryReportFilterItemChangedItem), var_export($searchCampaignChangeHistoryReportFilterItemChangedItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\ChangeEntityReportFilter', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\ChangeEntityReportFilter::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ItemChanged value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @uses \EnumType\ChangeEntityReportFilter::valueIsValid()
     * @uses \EnumType\ChangeEntityReportFilter::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $itemChanged
     * @return \StructType\SearchCampaignChangeHistoryReportFilter
     */
    public function setItemChanged(array $itemChanged = array())
    {
        // validation for constraint: list
        if ('' !== ($itemChangedArrayErrorMessage = self::validateItemChangedForArrayConstraintsFromSetItemChanged($itemChanged))) {
            throw new \InvalidArgumentException($itemChangedArrayErrorMessage, __LINE__);
        }
        if (is_null($itemChanged) || (is_array($itemChanged) && empty($itemChanged))) {
            unset($this->ItemChanged);
        } else {
            $this->ItemChanged = is_array($itemChanged) ? implode(' ', $itemChanged) : null;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SearchCampaignChangeHistoryReportFilter
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
